####            FUNCTIONS FOR B KING            ####################################################
##  Those are the functions used with the game.   ##################################################
##       Classes are in a separate file.          ##################################################
##                                                ##################################################

python early:
    
    import os
    import sys
    import random
    import math
    import copy
    import ConfigParser
    import ast
    from collections import defaultdict
    import operator
    from fractions import Fraction
    from collections import OrderedDict
    

init -3 python:

    def list_girl_packs(): # Returns a list of girl pack folders. Used for CG gallery
        
        pack_list = []
        
        for file in [f for f in renpy.list_files() if f.startswith("girls/") and is_imgfile(f)]:
                
            file_parts = file.split("/")
            
            if file_parts[1] not in pack_list:
                pack_list.append(file_parts[1])
                
        return pack_list
    
    def generate_girls():
        #<Chris12 PackState>
        # Use the new GirlFilesDict when generating new girls
        glist = list()
 
        for girlpath in GirlFilesDict.get_paths() :
            newGirl = Girl()
            newGirl.path = girlpath
            glist.append(newGirl)        
        #</Chris12 PackState>

        ## SHOWING BUTTS ##
        
        for girl in glist:
            
            girl.load_ini()
            girl.load_pics()
            
        if not glist:
            renpy.say("", event_color["bad"] % "The game couldn't find a girl pack in the '{i}game\\girls{/i}' folder." + "\nHave you downloaded and installed a girl pack?\nVisit [URL] to get your first girl packs.")
#            raise AssertionError, "No girls found! Did you download a girl pack?"
            renpy.say("", "Exiting Ren'Py...{w=1}{nw}")
            renpy.quit()
            
        return glist
                
                
                
    def get_name(dir, full=False): #*
        
        """ Breaks down a dir name into a first name/last name """
        
        ## Only works with formats like "name", "name surname" or "name_surname". The "_" operator takes precedence over " ", 
        ## which could be useful for composed first names
        
        dir_parts = dir.split("/")
        
        dir = dir_parts[-1]
        
        if dir.count("_") == 1:
            char = dir.find("_")
            
            first_name = dir[:char]
            last_name = dir[char+1:]
        
        elif dir.count(" ") >= 1:
            char = dir.find(" ")
            
            first_name = dir[:char]
            last_name = dir[char+1:]
        
        else:
            first_name = dir
            last_name = ""
        
        if full:
            return first_name + " " + last_name
        
        else:
            return first_name, last_name
    
    def get_girls(nb, free=False, p_traits=[], n_trait=None, perks=[]): # This will return a list of new girls, if possible using different templates and checking for duplicates
        
        template_girls = [g for g in generate_girls() if can_generate(g, free)] # Must be separate from available_templates to avoid creating new girl objects with every loop
        available_templates = []
        glist = []
        final_list = []
        
        while len(glist) < nb:
            if available_templates == []:
                available_templates = list(template_girls) # list() is necessary to make a true copy of template_girls
                renpy.random.shuffle(available_templates)
            
            # First looks for girls that haven't been generated at all
            
            for girl in available_templates:
                if girl not in glist and girl.count_occurences("all") == 0:
                    glist.append(girl)
                    available_templates.remove(girl)
                    if girl.init_dict["cloning options/unique"]:
                        template_girls.remove(girl)
                    break
            else:
                
                # Next looks for girls that aren't owned by player and have less than 3 occurences elsewhere
                
                for girl in available_templates:
                    if girl.init_dict["cloning options/unique"]: # This clears unique girls from the list
                        available_templates.remove(girl)
                    elif girl not in glist and girl.count_occurences("player") == 0 and girl.count_occurences("all") <= 3:
                        glist.append(girl)
                        available_templates.remove(girl)
                        break
                
                # Finally, looks for girls with the least occurences anywhere
                
                else:
                    found = False
                    i = 1
                    while not found:
                        i += 1
                        
                        if i > 200:
                            raise AssertionError, "Infinite loop detected: Error chasing duplicates"
                        
                        for girl in available_templates:
                            if girl.count_occurences("all") < i:
                                glist.append(girl)
                                available_templates.remove(girl)
                                found = True
                                break
        
        for template in glist:
            
            girl = copy.deepcopy(template)
            girl.id = game.girl_id_generated
            game.girl_id_generated += 1
            
            girl.randomize(free=free, p_traits=p_traits, n_trait=n_trait, perks=perks)
            final_list.append(girl)
            
            if girl.init_dict["background story/init_function"]:
#                renpy.say("", "Found " + girl.init_dict["background story/init_function"])
                try:
                    globals()[girl.init_dict["background story/init_function"]](girl)
                except:
                    raise AssertionError, "Function " + girl.init_dict["background story/init_function"] + " in " + girl.path + "/_BK.ini doesn't exist or failed."
                

        return final_list



### RANDOM AND NUMBERS FUNCTIONS ###
        
    def dice(sides, number = 1):
        """Randomly generates a number of dices with a result from 1 to sides"""
        
        return sum(renpy.random.randint(1, sides) for i in xrange(number))
        
        
    def rand_choice(li, nb = 1): # returns False for an empty list
        
        if li:
            if nb == 1:
                return renpy.random.choice(li)
            else:
                try:
                    return renpy.random.sample(li, k=nb)
                except:
                    return li
        else:
            return False
    
    
    def weighted_choice(li): #Where list is a list of tuples with item, weight
        
        weighted_list = []
        
        for x, w in li:
            weighted_list += [x] * round_int(w)
        
        if weighted_list:
            return renpy.random.choice(weighted_list)
        else:
            return False

        
        
    def round_int(x): # Rounds to the nearest decimal number (remember to force a float when dividing two integers, python is a dick about that)
        
        x = float(x)
        
        return int(round(x))
    
    def str_int(x):
        return str(round_int(x))
    
    def round_down(x):
        return int(x)
        
    def round_up(x):
        if int(x) < x:
            return int(x) + 1
        else:
            return int(x)

    def round_best(x, decimals=1):
            
        for d in xrange(decimals):
            if not (x * 10 ** (d)) % 1:
                if d == 0:
                    return int(x)
                else:
                    return round(x, d)
                    
        return round(x, decimals)


    def update_slaves():

        nb = dice(6)+5
        
        slavemarket.girls = [] # Empties slavemarket to get another chance at generating an original girl
        slavemarket.girls = get_girls(nb)
        
        slavemarket.updated = True
            
        return
        
        
    def update_free_girls(): # Generates a list of girls that will cycle around the city
        
        # Removes girls that haven't been talked to for 8 weeks
        game.free_girls[:] = [girl for girl in game.free_girls if girl.talked_to_date >= calendar.time - 56]
        
        # Randomly removes girls that haven't been met by the player on a roll of 1 on a d6
        game.free_girls[:] = [girl for girl in game.free_girls if (dice(6) > 1 or girl.MC_interact)]
        
        # Adds new girls as necessary to fill up the city streets
        if district.rank == 1:
            nb = free_girls_per_district
            
        elif district.rank == 2:
            nb = free_girls_per_district * 3
        
        elif district.rank == 3:
            nb = free_girls_per_district * 5
        
        else:
            nb = free_girls_per_district * 6
        
        if len(game.free_girls) < nb:
            game.free_girls += get_girls(nb - len(game.free_girls), free=True)
        
        return
        
    
    def refresh_available_locations():
        
        """ This creates 3 free girl slots for every location available to the player """
        
        game.locations = []
        
        loc_list = game.get_available_locations()
        
        for loc in loc_list:
            game.locations.append(loc.name)
            game.locations.append(loc.name)
            game.locations.append(loc.name)
    
    
    def reset_girl_jobs():

        for girl in MC.girls and farm.girls:
            if girl.job in ("waitress", "geisha", "masseuse", "dancer"):
                if not brothel.can_have(girl.job):
                    girl.set_job(None)
                    
        return
    

    def cycle_free_girls():
        
        renpy.random.shuffle(game.free_girls)
        renpy.random.shuffle(game.locations)
        
        for loc in game.locations:
            location_dict[loc].girls = []
        
        i = 0
                    
        for girl in game.free_girls:
            
            girl.location = game.locations[i]
            location_dict[game.locations[i]].girls.append(girl)
            
            i += 1

        return
    
    def update_market():
        calendar.discounted = []
        calendar.scarce = []
        
        d = dice(100)
        
        if d >= 98: # Everything is cheap this week
            calendar.discounted = build_resources
        elif d >= 95:
            calendar.discounted = ["marble", "ore", "silk"]
        elif d >= 91:
            calendar.discounted = ["wood", "leather", "dye"]
        elif d <= 2: # Everything is expensive
            calendar.scarce = build_resources
        elif d <= 5:
            calendar.scarce = ["marble", "ore", "silk"]
        elif d <= 9:
            calendar.scarce = ["wood", "leather", "dye"]
        else:
            calendar.discounted = [rand_choice(build_resources)]
            calendar.scarce = [rand_choice(build_resources)]
            
            if calendar.discounted == calendar.scarce:
                calendar.discounted = []
                calendar.scarce = []
                
        return
        
    
    def update_shops():
        
        # Item shop
        
        shop.items = []
        
        shop_mix = [
            ("junk", dice(3)+3),
            ("common", dice(6)),
            ("rare", dice(3)),
            ("exceptional", dice(3)-2)
            ]
        
        for quality, number in shop_mix:
            for i in xrange(number):
                it = get_rand_item(quality)
                shop.items.append(it)
        
        shop.items.sort(key=lambda x: x.price)
        
        shop.updated = True
        
        # City merchants
        
        for merc in city_merchants:
            
            merc.items = []
            
            shop_mix = [
            ("junk", dice(6)),
            ("common", dice(6)+2),
            ("rare", dice(3)+1),
            ("exceptional", dice(3)-1)
            ]
            
            for quality, number in shop_mix:
                for i in range(number):
                    it = get_rand_item(quality, item_types=merc.item_types)
                    if it:
                        merc.items.append(it)
                    elif quality != "junk": # Avoids incomplete inventory if all available items are junk
                        it = get_rand_item("junk", item_types=merc.item_types)
                        if it:
                            merc.items.append(it)
                
                merc.items.sort(key=lambda x: x.price)
                
                merc.updated = True
        
        # Minion merchants
        
#        for merc in (stallion_merchant, beast_merchant, monster_merchant, machine_merchant):
        
        NPC_stella.items = get_rand_minion("stallion", nb=dice(5))
        NPC_goldie.items = get_rand_minion("beast", nb=dice(5))
        NPC_willow.items = get_rand_minion("monster", nb=dice(5))
        NPC_gina.items = get_rand_minion("machine", nb=dice(3))
        
        for i in xrange(dice(4)-1):
            NPC_stella.items.append(get_rand_item(rank="M"))
            NPC_goldie.items.append(get_rand_item(rank="M"))
            NPC_willow.items.append(get_rand_item(rank="M"))
            NPC_gina.items.append(get_rand_item(rank="M"))
        
        if NPC_gina.flags["extractor1 unlock"]:
            if dice(6) >= 4:
                NPC_gina.items.append(extractor_items["extractor1"])
                
        if NPC_gina.flags["extractor2 unlock"]:
            if dice(6) >= 5:
                NPC_gina.items.append(extractor_items["extractor2"])
        
        return
    
    def get_rand_minion(type, nb):
        
        minions = []
        
        for i in xrange(nb):
            level = dice(district.rank) - 1
            minions.append(Minion(type, level))
            
        return minions
    
    def generate_template_items(items):
        
        #Generate variable quality items
        
        new_items = []
        
        for it in items:
                    
            for i in range(0,7):
                
                if it.min_rank <= i <= it.max_rank:
                
                    new_it = it.generate_new_item(i)
                    
                    new_items.append(new_it)
                    
        return new_items
    
    
    def init_items():
        
        # Creates a ranked dictionary for all items
        
        game.items = defaultdict(list)
        
        for it in all_items:
            
            game.items[it.rarity].append(it)
            
            for dis in district_dict.values() + [endless_district]:
                if it.min_rank <= dis.rank <= it.max_rank:
                    if it.rarity in ("U", "S", "M"):
                        pass
                    elif it.rarity < dis.rank:
                        dis.items["junk"].append(it)
                    elif it.rarity == dis.rank:
                        dis.items["common"].append(it)
                    elif it.rarity == dis.rank + 1:
                        dis.items["rare"].append(it)
                    else:
                        dis.items["exceptional"].append(it)
                        
#        list_district_items()
                        
    def list_district_items():
        tlist = []
        
        for dis in district_dict.values() + [endless_district]:
            for qual in ("junk", "common", "rare", "exceptional"):
                tlist.append([dis.name + " " + qual, and_text([say_name(it) for it in dis.items[qual]])])
                
        while tlist:
            name, itlist = tlist.pop(0)
            renpy.say(name, itlist)
            
        
    def say_name(it):
        if it:
            return it.name
        else:
            return "None"
        

#    def list_items(rank = 1):
        
#        district.items = defaultdict(list)
        
#        district.items["junk"] += game.items[rank - 1]
#        district.items["common"] += game.items[rank]
#        district.items["rare"] += game.items[rank + 1]
#        district.items["exceptional"] += game.items[rank + 2]

#        return
        
        
    def get_rand_item(quality = "junk", rank = None, item_type = None, item_types = []):
        
        if rank:
            return copy.deepcopy(rand_choice(game.items[rank]))
        
        elif item_types:
            return copy.deepcopy(rand_choice([it for it in district.items[quality] if it.type.name in item_types]))
        
        elif item_type:
            return copy.deepcopy(rand_choice([it for it in district.items[quality] if it.type.name == item_type.name]))
        
        else:
            return copy.deepcopy(rand_choice(district.items[quality]))
                    
    def can_pay(price):
        
        if MC.gold >= price:
            return True
        
        else:
            return False
        
        
    def roll_result(crit_success = 95, crit_fail = 5 ): # This rolls a dice to randomize the result a little
            
        r = dice(100)
        
        if r <= crit_fail:
            return "critical failure"
            
        elif r <= 25:
            return "failure"
            
        elif r <= 75:
            return "neutral"
            
        elif r <= crit_success:
            return "success"
            
        elif r <= 100:
            return "critical success"

    
    def show_tt(pos="top_right"):
        
        tt = Tooltip("")
        
        if pos == "center":
            renpy.show_screen("tool", x = 0.5, y = 0.5, w = 300, h = 150)
            
        elif pos == "right":
            renpy.show_screen("tool", x = 1.0, y = 0.7, w = 215, h = 150)
            
        elif pos == "top_right":
            renpy.show_screen("tool", x = 0.7, y = 0.0, w = 0.32, h = 0.1, bg = False)
            
        elif pos == "hide":
            renpy.hide_screen("tool")
            
        return tt
        
        
    def set_girls_workdays():
        
        for girl in MC.girls:
            girl.set_workdays()
        
    def get_description(basetext, effects, separator="\n"):
        
        if basetext != "":
            text1 = "{i}" + basetext + "{/i}"
            
        else:
            text1 = ""
            
        begin = True
        
        for effect in effects:
            
            d = effect.get_description()
            
            if begin and d:

                if text1:
                    text1 += separator
                
                text1 += d.capitalize()
                begin = False
            
            elif not begin and d:
                text1 += ", " + d


        return text1
        

    def get_change_text(changes): ## Where 'changes' is a tuple with (stat_name, nb)
        
        text_changes = ""
        
        for c in changes:
                
            stat, nb = c
            
            if stat in ("rep", "reputation"):
                if nb > 0:
                    text_changes += stat_increase_dict["rep"] % str(round_int(nb))
                else:
                    text_changes += stat_increase_dict["rep_neg"] % str(round_int(nb))
            
            elif stat == "gold":
                if nb > 0:
                    text_changes += stat_increase_dict["gold+"] % str_int(nb)
                else:
                    text_changes += stat_increase_dict["gold-"] % str_int(nb)
            
            else:
                if nb > 0:
                    text_changes += stat_increase_dict["stat"] % (stat.capitalize(), str(round_int(nb)))
            
                else:
                    text_changes += stat_increase_dict["stat_neg"] % (stat.capitalize(), str(round_int(nb)))
                    
        return text_changes
        
    
    def load_quest_pics(): ## Loads quests and class pics
        
        quest_board.pics = []
        
        # Looking for picture in quests directory
        
        imgfiles = [file for file in renpy.list_files() if file.startswith("quests/") and is_imgfile(file)]
        
        # Attaching each picture to the list with appropriate tags
        
        for file in imgfiles:
            
            file_name = file.split("/")[-1]

            quest_board.pics.append(Picture(file_name, file))
        
        
    def update_quests():
        
        quest_board.quests = []
        quest_board.classes = []
        
        quest_nb = 2 + dice(6)
        
        class_nb = 2 + dice(6)
        
        for i in range(quest_nb):
            
            q = copy.copy(rand_choice(quest_templates))
            
            d = dice(6)
            
            if district.rank <= 1 or d >= 4:
                q.randomize(district.rank)
            elif district.rank <= 2 or d >= 2:
                q.randomize(district.rank-1)
            else:
                q.randomize(dice(district.rank-2))
            
            quest_board.quests.append(q)
        
        for i in range(class_nb):
            
            c = copy.copy(rand_choice(class_templates))
            
            d = dice(6)
            
            if district.rank <= 1 or d >= 4:
                c.randomize(district.rank)
            elif district.rank <= 2 or d >= 2:
                c.randomize(district.rank-1)
            else:
                c.randomize(dice(district.rank-2))
            
            quest_board.classes.append(c)
            
        quest_board.updated = True
    
    
    def rape_attempt(girl, cust, threat):
        
        renpy.notify("Rape attempt")
        
        text_descript = " Even though she refused, the customer tried to force her to do it. "
        raped = False
                
        if brothel.get_security() >= threat: #You have enough guards to look after your girls
            
            text_descript += girl.name + " {color=[c_green]}called security. He apologized and decided to play nice.{/color}"
            
            girl.change_mood(1)
            girl.change_fear(-1)
            
        elif MC.can_defend() and MC.get_defense() > girl.get_defense(): #You don't have enough guards but the Player is available and tougher than your girl
            
            if MC.get_defense() >= cust.get_defense():
                
                text_descript += "{color=[c_green]}You heard %s crying for help and threatened to throw him out. He decided to play nice.{/color}" % girl.name
                
                girl.change_mood(1)
                girl.change_love(1)
                girl.change_fear(-2)
                
            elif not girl.test_shield():
                
                text_descript += "{color=[c_red]}You tried to help, but the customer knocked you out and locked the door shut.{/color}"
                raped = True
                
                girl.change_mood(-3)
                girl.change_love(-1)
                girl.change_fear(3)
                
            else:
                text_descript += "Fortunately, her magic shield protected her. The customer was awed and sheepishly agreed to back off."
                
            MC.interactions -= 1
                
        else: #You don't have enough guards and the Player is not available or weaker than your girl: she's on her own
            
            # May get a boost of debuff from past interactions with MC
            
            mod = 0
            
            if girl.remembers("reward", "defended") or girl.remembers("punish", "hurt"):
                mod = 1
            elif girl.remembers("punish", "defended"):
                mod = -1
            
            if girl.get_defense() + mod >= cust.get_defense():
                
                text_descript += "{color=[c_green]}%s told him he could play nice or loose an important body part. He changed his mind.{/color}" % girl.name
                
                girl.track_event("defended")
                
            elif not girl.test_shield():
                
                text_descript += "{color=[c_red]}%s tried to fight him to no avail, and he had his way with her.{/color}" % girl.name
                raped = True
                
                girl.change_mood(-3)
                girl.change_fear(3)
                
        return raped, text_descript
    
    def crazy_customer(girls, customers):
        
    ## Tests for violence and arson attempts (returns event if True)
        
        girl = rand_choice(girls)
        for cust in customers:

            if cust.crazy == "violent":
                
                renpy.notify("Assault attempt")
                violent_text = cust.name + " went berserk and attacked " + girl.name + " all of a sudden!"
                violent_report = "Security alert! Violent customer."
                
                if brothel.get_risk() < 0: # Your guards on duty are ready to help
                    reward = (cust.diff  + dice(cust.diff)) * district.rank
                    violent_text += "\n{color=[c_green]}Fortunately, your security is close at hand. They quickly gang up on him and proceed to beat the crap out of his sorry ass.\n{/color}Your girl is safe, and you pocket the content of his wallet: " + str(reward) + " gold."
                    violent_report = "{color=[c_green]}" + violent_report + " Your guards beat him up.{/color}"
                    girl.change_fear(-1)
                    MC.gold += reward
                    
                    pic = Picture(path="events/" + rand_choice(security_pics["girl defense"]))
            
                elif MC.can_defend() and MC.get_defense() > girl.get_defense(): # Your guards are somewhere else, your girl is helpless, it's your turn to take action!
                    if fight(cust, MC) == False:
                        reward = (cust.diff  + dice(cust.diff)) * district.rank
                        violent_text += "\n{color=[c_green]}You rush to the scene and break the guy's face before he has any time to act.\n{/color}Your girl is safe, and you pocket the content of his wallet: " + str(reward) + " gold."
                        violent_report = "{color=[c_green]}" + violent_report + " You beat him up.{/color}"
                        girl.change_fear(-2)
                        girl.change_love(1)
                        MC.gold += reward
                        
                        pic = Picture(path="events/" + rand_choice(security_pics["girl defense"]))
                        
                    elif girl.test_shield():
                        violent_text += " She was protected by a magic shield."
                        
                        pic = Picture(path="events/" + rand_choice(security_pics["girl shield"]))
                        
                    else:
                        violent_text += "\n{color=[c_red]}You try to help her but the bastard knocks you to the ground and beats up the both of you.\n{/color}" + girl.name + " is hurt, and you loose some self-respect."
                        girl.get_hurt(dice(3)+1)
                        girl.add_log("hurt_days")
                        
                        girl.track_event("hurt", "a violent customer")
                        
                        violent_report = "{color=[c_red]}" + violent_report + " He beat you up and [girl.name] is hurt.{/color} " + girl.name
                        girl.change_fear(2)
                        girl.change_love(-1)
                        
                        pic = Picture(path="events/" + rand_choice(violent_pics))
                        
                        
                            
                else: # Your girl must defend herself!
                    
                    mod = 0
                    
                    if girl.remembers("reward", "defended") or girl.remembers("punish", "hurt"):
                        mod = 1
                    elif girl.remembers("punish", "defended"):
                        mod = -1
                    
                    if girl.get_defense() + mod >= cust.get_defense():
                        reward = (cust.diff  + dice(cust.diff)) * district.rank
                        violent_text += ("\n{color=[c_green]}Your girl has the means to defend herself, however. " + rand_choice(["She stabs the poor sod in the guts, stopping him right in his tracks.", 
                                        "She knees the bastard right in the balls and he crumbles on the floor crying.", "She kicks him right in the face, knocking him out for good."]) 
                                        + "\n{/color}Your girl is safe, and you pocket the content of his wallet while your henchmen throw the poor sucker out in a dark alley: " + str(reward) + " gold.")
                        
                        violent_report = "{color=[c_green]}" + violent_report +" [girl.name] beat him up.{/color} " + girl.name
                        
                        girl.track_event("defended")
                        
                        girl.change_fear(-1)
                        MC.gold += reward
                        
                        pic = girl.get_pic("fight", strict=True, naked_filter=True, soft=True)
                        
                        if not pic:
                            pic = girl.get_pic("fight", strict=True)
                            if not pic:
                                pic = Picture(path="events/" + rand_choice(security_pics["default girl fight"]))
                        
                    elif girl.test_shield():
                        violent_text += " She was protected by a magic shield."
                        
                        pic = Picture(path="events/" + rand_choice(security_pics["girl shield"]))
                        
                    else:
                        violent_text += "\n{color=[c_red]}Your girl tried to defend herself but he is stronger, kicking her to ground and pummeling her with his fists.\n{/color}You finally throw him out, but " + girl.name + " is hurt."
                        girl.get_hurt(dice(3)+1)
                        girl.add_log("hurt_days")
                        
                        girl.track_event("hurt", "a violent customer")
                        
                        violent_report = "{color=[c_red]}" + violent_report + " [girl.name] is hurt.{/color}"
                        girl.change_fear(1)

                        pic = Picture(path="events/" + rand_choice(violent_pics))

                log.add_report(violent_report)
                return Event(pic, text = violent_text, sound = "punch.wav", with_st = vpunch), cust
            
            elif cust.crazy == "arsonist":
                
                renpy.notify("Arson attempt")
                arson_text = ""
                arson_report = "Security alert! Fire started."
                arson = False
                
                if brothel.get_risk() < 0: # Your guards on duty are ready to help
                    arson_text += cust.name + " tried to set fire to your brothel!\n{color=[c_green]}Your guards tackled him and fucked him up before he could light a match.{/color}"
                    arson_report = "{color=[c_green]}" + arson_report + " Your guards stopped it.{/color}"
                    
                elif MC.can_defend(): # Your guards are somewhere else, it's your turn to take action!
                    if fight(cust, MC) == False:
                        arson_text += cust.name + " tried to set fire to your brothel!\n{color=[c_green]}You were patrolling as it happened, and knocked the wretch senseless before he could carry out his plan.{/color}"
                        arson_report = "{color=[c_green]}" + arson_report + " You stopped it.{/color}"
                    else:
                        arson_text += cust.name + " tried to set fire to your brothel!\n{color=[c_red]}You tried to stop him but he fought you like a madman, allowing time for the flames to grow high.{/color}"
                        arson_report = "{color=[c_red]}" + arson_report + " You were beaten and the brothel caught fire.{/color}"
                        arson = True
                    MC.interactions -= 1
                
                else: # No one is here to help out
                    arson_text += cust.name + "{color=[c_red]} has set fire to your brothel!\nYou hear your girls yell, and soon see the smoke rising from your burning estate.{/color}"
                    arson_report = "{color=[c_red]}" + arson_report + " The bro- The bro- The brothel's on fire!{/color}"
                    arson = True
                
                if arson:
                    if MC.playerclass == "Wizard":
                        damage = dice(25) + 25 - 5 * MC.get_spirit()
                        if damage < 0:
                            damage = 0
                        
                        arson_text += "\nGathering the power of the Storm, you quickly cast a raining spell. In the end, damage is limited. Your brothel condition deteriorates by " + str(damage)
                        brothel.change_dirt(damage)
                        
                    else:
                        damage = dice(25) + 25
                        arson_text += "\nYou work together with your staff and some helpful customers to extinguish the flames. Alas, the place has been badly damaged. Your brothel condition deteriorates by " + str(damage)
                        brothel.change_dirt(damage)
                
                pic = rand_choice(arson_pics)

                log.add_report(arson_report)
                return Event(Picture(pic, "events/" + pic), text = arson_text, sound = "fire.wav", with_st = vpunch), cust
                
        return False, False

    
    def reset_alerts():
        
        for k in seen_alerts:
            seen_alerts[k] = False
        
        return
    
    
    def plus_text(nb):
        
        if nb > 0:
            return "+" + str(nb)
            
        else:
            return str(nb)
    
    def and_text(li):
        
        if not li:
            return "No list"
        
        if len(li) == 1:
            return li[0]
            
        elif len(li) > 1:
            return ", ".join(li[:-1]) + " and " + li[-1]
            
        else:
            return "No list"
                
            
    def plural(nb, ending = "s", singular=""):
        
        if nb == 1:
            return singular
        
        else:
            return ending
            
    def article(noun):
        
        if noun[0].lower() in ("a", "i", "e", "o"):
            
            return "an " + noun
            
        else:
            
            return "a " + noun
            
    def season_text(d): # Where d is a dictionary containing text for all 4 seasons
        return d[calendar.get_season()]
    
    def capitalize(s):
        return s[:1].upper() + s[1:]        
        
    def uncapitalize(s):
        return s[:1].lower() + s[1:]
            
    def help(screen, kwargs):
            
        target = "help"
        renpy.call(target, screen)
        
        return
    
    
    def fight(attacker, defender, advantage = "defender"): # Returns True if attacker won, False otherwise
        
        attack = attacker.get_defense(fight = True) + dice(6)
        defense = defender.get_defense(fight = True) + dice(6)
        
        if attack > defense:
            return True
            
        elif defense > attack:
            return False
        
        elif attack == defense and advantage == "attacker":
            return True
        
        elif attack == defense and advantage == "defender":
            return False
        
        else:
            return "tie"
        
    def get_gossip():
        
        # Story gossip is added at the end of each Chapter
        
        try:
            return rand_choice(generic_gossip + story_gossip + chapter_gossip[game.chapter] + district_gossip[selected_district.name])
        except:
            return rand_choice(generic_gossip)
        
    def acquire_girl(girl, free = False):
        
        MC.girls.append(girl)
        
        if free:
            game.free_girls.remove(girl)
        
        girl.set_workdays()
        
        girl.log["acquired"] = calendar.time
        girl.track_event("acquired", arg=girl.name)
        
        
    def search_items(key):
        
        list = []
        
        for it in all_items:
                    
            if key in it.name:
                
                list.append(it)
                
        return list
        
    
    def diff_description(diff):
        
        if diff <= 25:
            d = "Very easy"
            col = "c_green"
            
        elif diff <= 50:
            d = "Easy"
            col = "c_lightgreen"
            
        elif diff <= 100:
            d = "Medium"
            col = "c_yellow"
    
        elif diff <= 150:
            d = "Hard"
            col = "c_lightred"
            
        else:
            d = "Very hard"
            col = "c_crimson"
            
        return "{color=[" + col + "]}" + d + "{/color}"
        
        
        
        
## Performing (waitress, masseuse, geisha, dancer, whore)

    def perform(act, girls, customers, customer_reason = "", job_filter=False): # job_filter forces the use of the current job's tag as 'and_tag'
        
        # Checks for crazy customers
        
        crazy_ev, crazy_cust = crazy_customer(girls, customers)
        
        if crazy_ev:
            customers.remove(crazy_cust)
            crazy_cust.crazy = False # Prevents craziness from triggering twice
            if not customers or girls[0].hurt > 0: # Aborpts performance if all customers became violent/girl got hurt
                return [crazy_ev]

        xp_gains = defaultdict(int)
        rep_gains = defaultdict(int)
        jp_gains = defaultdict(int)
        tip_gains = defaultdict(int)
        
        stat_gains = defaultdict(list)
        
        level_up = defaultdict(bool)
        job_up = defaultdict(bool)
        
        ev_type = "Normal"
        
        specials = []
        first_customer = defaultdict(bool)
        finish = False
        rape = False
        rand_item = None
        rape_text = ""
        tip_special = ""
        
        ## Update girls and customers flags
        
        for girl in girls:
            if not girl.has_worked:
                girl.has_worked = defaultdict(bool)
            
            if not girl.has_worked[calendar.time]:
                girl.has_worked[calendar.time] = True
                first_customer[girl] = True
        
        if act in all_jobs:
            for cust in customers:
                cust.got_entertainment = act
        elif act in all_sex_acts:
            for cust in customers:
                cust.got_sex_act = act
        else:
            raise AssertionError, str(act) + " is not a valid job or sex act for " + girls[0].fullname
            
        ## STEP 1: Get customers difficulty
        
#        renpy.say("", str(len(customers)) + "came to see " + and_text([g.name for g in girls]))
        
        diff = sum(c.diff for c in customers) / len(customers)
        
        
        ## STEP 2: Get customer satisfaction
        
        entertainment_bonus = 0
        sex_act_bonus = 0
                                    
        if act in all_jobs:
            # Customers special effects (only one customer result applies: too easy?)
            
            # As suggested by Chris12
            entertainment_bonus -= (sum(cust.rank for cust in customers if cust.wants_entertainment != cust.got_entertainment)) / len(customers)
            
            entertainment_bonus += rand_choice(customers).get_effect("change", "satisfaction")
            # Up until this point, 'entertainment_bonus' is actually negative
            
            # Lowering malus with effects such as the Party Girl perk
            entertainment_bonus *= girls[0].get_effect("boost", "customer penalties")
            entertainment_bonus += sum(g.get_effect("increase satisfaction", "all jobs") for g in girls)
        
        elif act in all_sex_acts:
            # Customers special effects (only one customer result applies: too easy?)
            sex_act_bonus += rand_choice(customers).get_effect("change", "satisfaction")
            if len(customers) > 1 or len(girls) > 1: # Customers are always happy in groups
                if sex_act_bonus < 0:
                    sex_act_bonus = 0
                
                if len(customers) > 1:
                    sex_act_bonus += sum(g.get_effect("increase satisfaction", "group") for g in girls)
                if len(girls) > 1:
                    sex_act_bonus += sum(g.get_effect("increase satisfaction", "bisexual") for g in girls)
                
            else:
                if customers[0].wants_sex_act != customers[0].got_sex_act:
                    for girl in girls:
                        if girl.get_effect("special", "temptress"):
                            customers[0].wants_sex_act = customers[0].got_sex_act
                            specials.append("temptress")
                            break
                    else:
                        
                        # Rape attempts
                        
                        if customers[0].crazy == "rapist":
                            rape, rape_text = rape_attempt(girl, customers[0], brothel.get_threat())
                            if rape:
                                act = customers[0].wants_sex_act
                                customers[0].got_sex_act = act
                            else:
                                sex_act_bonus = -1 * customers[0].rank
                        else:
                            sex_act_bonus = -1 * customers[0].rank
            
            sex_act_bonus += sum(g.get_effect("increase satisfaction", "all sex acts") for g in girls)
            
            #<Chris Job Mod: Bonus/Malus from Entertainment Score>
            if game.has_active_mod("chrisjobmod"):
                sex_act_bonus += ((cust.entertainment_score - entertainment_neutral_score) * entertainment_bonus_strength)
            #</Chris Job Mod>
        
        # Improve customer mood if the bedroom type is better (lowers it if it isn't)
        
        cust_bonus = round_int(entertainment_bonus + sex_act_bonus + sum(g.get_effect("increase satisfaction", act) for g in girls) + brothel.get_mood_modifier(district.rank))
                
        # Special interactions
        
        for girl in girls:
            if first_customer[girl]:
                cust_bonus += girl.get_effect("change", "first customer satisfaction")
            
            
            # BBCR bonus (may boost tip if procs depending on stat)
            if girl.get_effect("special", "BBCR bonus"):
                
                spe = girl.get_stat(rand_choice(["beauty", "body", "charm", "refinement"])) - diff
                    
                if spe > 0:
                    tip_gains[girl] += spe
                    specials.append(stat + " bonus")
            
            # LOCS bonus (may boost tip if procs depending on stat)
            if girl.get_effect("special", "LOCS bonus"):
                
                spe = girl.get_stat(rand_choice(["libido", "obedience", "constitution", "sensitivity"])) - diff
                
                if spe > 0:
                    tip_gains[girl] += spe
                    specials.append(stat + " bonus")
            
            # Lost and Found perk
            
            if girl.get_effect("special", "random item"):
                specials.append("random item")
                d = dice(6)
                if d == 6:
                    rand_item = get_rand_item("rare")
                elif d >= 4:
                    rand_item = get_rand_item("common")
                else:
                    rand_item = get_rand_item()
                girl.items.append(rand_item)
            
            
        if act in all_jobs:
            for girl in girls:
                
                # Flasher
                if girl.get_effect("special", "flasher"):
                    cust_bonus += spe
                    rep_gains[girl] += 1
                    specials.append("flasher")
        
        elif act in all_sex_acts:
            
            if len(customers) > 1:
                suf = "_group"
            else:
                suf = ""
            
            for girl in girls:
                
                # Virgin
                if act == "sex":
                    if girl.pop_virginity():
                        cust_bonus += 3
                        tip_gains[girl] += 100
                        specials.append("virgin" + suf)
                
                # DT
                spe = girl.get_effect("special", "deep throat")
                if spe and act == "service":
                    cust_bonus += spe
                    specials.append("DT" + suf)

                # Irrumatio
                if girl.get_effect("special", "irrumatio") and act == "service":
                    girl.change_stat("obedience", 1)
                    stat_gains[girl].append(("obedience", 1))
                    specials.append("irrumatio")
                        
                # Buk
                if girl.get_effect("special", "bukkake") and len(customers) > 1  and not finish:
                    cust_bonus += len(customers)
                    finish = True
                    brothel.change_dirt(len(customers))
                    specials.append("bukkake")
                
                # Creampie
                spe = girl.get_effect("special", "creampie")
                if spe and act == "sex" and not finish:
                    cust_bonus += spe
                    specials.append("creampie" + suf)
                    finish = True
                    brothel.change_dirt(1)
                
                # A. Creampie
                spe = girl.get_effect("special", "anal creampie")
                if spe and act == "anal" and not finish:
                    cust_bonus += spe
                    specials.append("anal creampie" + suf)
                    finish = True
                    brothel.change_dirt(1)
                        
                # Cum on face
                spe = girl.get_effect("special", "cum on face")
                if spe and not finish:
                    cust_bonus += spe
                    specials.append("cum on face" + suf)
                    finish = True
                    brothel.change_dirt(1)
                
                # Swallow
                if girl.get_effect("special", "swallow") and not finish:
                    tip_gains[girl] += 25 * customers[0].rank
                    rep_gains[girl] += 1
                    finish = True
                    if girl.get_effect("special", "catgirl"):
                        specials.append("catgirl")
                    else:
                        specials.append("swallow")
                
#                # Heart of gold/Elite pickpocket and Pickpocket perks (including Renza's trainer effect)
                
                # Pickpocket (Hard-coded)
                
                boost = 0
                caught_chance = 0
                
                # Converts the pickpocket trait to elite if Renza's effect is on
                if brothel.get_effect("special", "pickpocket") and girl.get_effect("special", "pickpocket", raw=True):
                    if renpy.random.random() <= 0.25:
                        boost = 0.1
                
                # Regular pickpocket effect
                elif girl.get_effect("special", "pickpocket"):
                    if renpy.random.random() <= 0.25:
                        boost = 0.1
                        caught_chance = 0.15
                
                # Applying pickpocket effect
                if boost:
                    gain = round_int(spe * tip_gains[girl])
                    tip_gains[girl] += gain
                    tip_special = " (" + str(gain) + " from picking pockets"
                    if renpy.random.random() <= caught_chance:
                        girl.change_rep(-1)
                        brothel.change_rep(-1 * district.rank)
                        tip_special += ", but she was seen"
                    tip_special += ")"
                                
            
        ## STEP 3: Calculate stat bonus
        
        stat_bonus = sum(girl.test_stats(perform_job_dict[act + "_stats"], diff) for girl in girls) // len(girls)
        
        sensitivity_bonus = 0
        if act in all_sex_acts:
            
            # Sensitivity bonus for sex acts
            
            for girl in girls:
                s = girl.get_stat("sensitivity") - diff
            
                if s >= 25:
                    sensitivity_bonus += 2
                elif s >= 10:
                    sensitivity_bonus += 1
                elif s <= -25:
                    sensitivity_bonus += -2
                elif s <= -10:
                    sensitivity_bonus += -1
                else:
                    sensitivity_bonus += 0
            
            sensitivity_bonus = sensitivity_bonus // len(girls)
            
        
        ## STEP 4: Get job level bonus
        
        job_bonus = sum(girl.job_level[act] for girl in girls) // len(girls)
        
        
        ## STEP 5: Misc. bonuses
        
        # Activate auto-work items
        item_used = False
        for it in girls[0].items:
            if item_used:
                break
            elif it.usage == "auto_work":
                for e in it.effects:
                    if e.target.startswith(act):
                        girls[0].use_item(it)
                        item_used = it
                        break
        
        # Apply misc effects
        if act in all_jobs:
            misc_bonus = brothel.get_effect("change", "all jobs") + sum(g.get_effect("change", "all jobs", raw=True) for g in girls)
        elif act in all_sex_acts:
            misc_bonus = brothel.get_effect("change", "all sex acts") + sum(g.get_effect("change", "all sex acts", raw=True) for g in girls)
            
        misc_bonus += brothel.get_effect("change", act + " results") + sum(girl.get_effect("change", act + " results", raw=True) for girl in girls)
        
        #<Chris Job Mod: Apply Difficulty Modifier for Job>
        if game.has_active_mod("chrisjobmod"):
            misc_bonus += act_difficulty_modifier[act]
        #</Chris Job Mod>
        
        # Memories of rewards and punishment
        
        for girl in girls:
            if girl.remembers("reward", "good result"):
                misc_bonus += 1
            if girl.remembers("punish", "bad result"):
                misc_bonus += 1
            
        
        ## STEP 6: roll dice
        
        d = dice(6)
        
        # re-rolls (traits/perks)
        
        if d == 1:
            #Reroll chance
            if girls[0].get_effect("reroll", "critical failure") > 0 or (girls[0].get_effect("reroll", "job critical failure") > 0 and act in all_jobs) or (girls[0].get_effect("reroll", "whore critical failure") > 0 and act in all_sex_acts):
                d = dice(6)
                specials.append("reroll")
    
        if d == 2:
            if girls[0].get_effect("special", "unlucky") > 0:
                d = 1
                specials.append("unlucky")
        
        if d == 5:
            if girls[0].get_effect("special", "lucky") > 0:
                d = 6
                specials.append("lucky")
                
        roll = roll_dict[d]
        
        
        ## STEP 7: Get final result
        
        # Calculate score and get result
        score = d + stat_bonus + cust_bonus + sensitivity_bonus + job_bonus + misc_bonus
        
        for k in sorted(result_dict):
            if score >= k:
                result = result_dict[k]
        
        #<Chris Job Mod: Assign the Score to all entertained customers>
        if game.has_active_mod("chrisjobmod"):
            if act in all_jobs:
                for cust in customers:
                    cust.entertainment_score = score
        #</Chris Job Mod>
        
        # Get xp, jp, tip and rep
        
        for girl in girls:
            xp_gains[girl] += girl.get_xp(act, result, customers)
            jp_gains[girl] += girl.get_jp(act, result, customers)
            rep_gains[girl] += girl.get_rep(score, customers)
            
            tip_gains[girl] += girl.get_tip(act, result, customers)
            
            if cust_bonus > 0:
                tip_gains[girl] += girl.get_effect("change", "tip", custom_scale=("customer satisfaction", cust_bonus))
            
            # Focus perk
            if girl.get_effect("special", "focus") and act in all_sex_acts:
                if girl.count_activated_sex_acts() == 1:
                    tip_gains[girl] *= 1.25
                    if rep_gains[girl] > 0:
                        rep_gains[girl] *= 1.25
            
            # Virgin whore perk
            if girl.has_trait("Virgin"):
                if rep_gains[girl] > 0:
                    rep_gains[girl] *= girl.get_effect("boost", "virgin rep")
                tip_gains[girl] *= girl.get_effect("boost", "virgin tip")
            
            # Reduces the boost by the number of customers to achieve the first customer effect
            
            if first_customer[girl]:
                rep_gains[girl] = rep_gains[girl] + (rep_gains[girl] * (girl.get_effect("boost", "first customer rep")-1) / len(customers))
                tip_gains[girl] = tip_gains[girl] + (tip_gains[girl] * (girl.get_effect("boost", "first customer tip")-1) / len(customers))
            
            if act in all_jobs:
                tip_gains[girl] *= girl.get_effect("boost", "tip", custom_scale=("job cust nb", len(customers)))
            elif act in all_sex_acts:
                tip_gains[girl] *= girl.get_effect("boost", "tip", custom_scale=("whore cust nb", girl.get_log("whore_cust", "today")))
            
        
        ## STEP 8: Apply Changes
        # Receive XP, JP and REP gains
            
            xp_gains[girl] = girl.change_xp(xp_gains[girl])
            jp_gains[girl] = girl.change_jp(jp_gains[girl], act)
            rep_gains[girl] = girl.change_rep(rep_gains[girl])
                        
            if girl.ready_to_level():
                level_up[girl] = True
                
            if girl.ready_to_job_up(act):
                job_up[girl] = True
        
        
        # Stats changes
        
        for girl in girls:
            stat_gains[girl] = girl.raise_stats(perform_job_dict[act + "_changes"])
        
        # Prestige and breaking
        
            if act in all_sex_acts:
                MC.change_prestige(girl.rank*girl.get_effect("boost", "prestige"))
                girl.raise_preference(act)
                
                if len(customers) > 1:
                    girl.raise_preference("group")
                if len(girls) > 1:
                    girl.raise_preference("bisexual")
                
            elif act in all_jobs and girl.get_effect("special", "job prestige"):
                MC.change_prestige(girl.rank*girl.get_effect("boost", "prestige"))
            
                
        ## STEP 9: Maintenance and tiredness
        
        # Use interactions (whoring only)
        
        if act in all_sex_acts:        
            for girl in girls:
                spent_interactions = 1

                # Uses 2 interactions if girl is working half a shift
                spent_interactions *= (100//girl.workdays[calendar.get_weekday()])

                # Uses 2 interactions if w&w
                if girl.work_whore and girl.job in all_jobs:
                    spent_interactions *= 2

                girl.interactions -= spent_interactions

        # Get tired
        
        if act in all_jobs or len(girls) > 1:
            tiredness = 5 * len(customers)
        else:
            tiredness = 10 * len(customers)
        
        #<Chris Job Mod>
        if game.has_active_mod("chrisjobmod"):
            tiredness = round_int(tiredness * act_tiredness_per_customer_modifier[act])
        #</Chris Job Mod>
        
        if "catgirl" in specials: 
            tiredness = round_int(tiredness * 0.75) # Ugly, should be changed
            
        for girl in girls:
            if girl == girls[0]: # Ugly, should be changed
                tired_description, tired_changes = girl.tire(tiredness)
            else:
                girl.tire(tiredness)
        
        # Get dirty
        
        if act in all_jobs:
            brothel.change_dirt(0.5 + len(customers) / 2)
        elif act in all_sex_acts:
            brothel.change_dirt(len(customers))
        
        
        
        ## STEP 10: Log, descriptions and event
                
        # Compose description
        
        cust_names = capitalize(and_text([c.name.lower() for c in customers]))
        girl_names = and_text([g.name for g in girls])
        
        if len(customers) > 1:
            cust_pronoun = "They"
            cust_verb = "were"
        else:
            cust_pronoun = "He"
            cust_verb = "was"
        if len(girls) > 1:
            girl_pronoun = "them"
        else:
            girl_pronoun = "her"
        
        if act in all_jobs:
            text_descript = perform_job_dict[act + "_init"] % (girl_names, len(customers))
                        
        elif act in all_sex_acts:
            text_descript = customers[0].reason.replace(":cust:", cust_names)
            text_descript = text_descript.replace(":pron:", cust_pronoun)
            text_descript = text_descript.replace(":verb:", cust_verb)
            text_descript = text_descript.replace(":girl:", girl_names)
            
#            try:
#                text_descript = customers[0].reason % (cust_names.capitalize(), cust_pronoun, cust_verb)
#            except:
#                try:
#                    text_descript = customers[0].reason % (cust_names.capitalize(), cust_pronoun)
#                except:
#                    text_descript = ("%s wanted to meet " + gstats_descript[customers[0].preference] + ". %s couldn't find a suitable girl.") % (cust_names.capitalize(), cust_pronoun)
##                    raise AssertionError, "Couldn't convert the following string: " + str(customers[0].reason)
            
        log.add_report(text_descript)
        
        if act in all_sex_acts:
            text_descript += perform_job_dict[customers[0].wants_sex_act + "_init"] % (cust_pronoun, girl_pronoun)
        
        if entertainment_bonus < 0:
            text_descript += "\nSome customers would have preferred to do something else."
        if sex_act_bonus < 0:
            text_descript += perform_job_dict["not satisfied"]
        
            
        if rape_text:
            text_descript += rape_text
        
        if item_used:
            text_descript += "\nShe used " + item_used.name.lower() + " to improve the mood."
        
        for spe in specials:
            try:
                text_descript += event_color["good"] % perform_job_dict[spe] % plural(len(customers))
            except:
                text_descript += event_color["good"] % perform_job_dict[spe]
        
        if act in all_sex_acts and len(customers) > 1:
            text_descript += perform_job_dict["roll_" + roll] % girl_names
            text_descript += perform_job_dict["group_" + result] % girl_names
        elif act in all_sex_acts and len(girls) > 1:
            text_descript += perform_job_dict["bisexual_roll_" + roll] % girl_names
            text_descript += perform_job_dict["bisexual_" + result] % girl_names
        else:
            text_descript += perform_job_dict["roll_" + roll] % girl_names
            text_descript += perform_job_dict[act + "_" + result] % girl_names
        
        text_descript += tired_description
        
        
        # Compose right text (changes)
        
        text_changes = "\nDiff.:\n" + diff_description(diff)
        text_changes += "\n\nRoll: " + "{image=" + "img_dice" + str(d) + "}"
        if "reroll" in specials:
            text_changes += " (Reroll)"
            ev_sound = s_dice
        text_changes += "\nSkill bonus: " + plus_text(stat_bonus + job_bonus)
        if sensitivity_bonus:
            text_changes += "\nSensit. bonus: " + plus_text(sensitivity_bonus)
        text_changes += "\nCust. bonus: " + plus_text(cust_bonus)
        text_changes += "\nOther: " + plus_text(misc_bonus)
        
        text_changes += "\n\n{b}Final result{/b}: " + str(score) + "\n({color=" + result_colors[result] + "}" + result + "{/color})\n"
        
        for girl in girls:
            if level_up[girl]:
                ev_type = "Level/Job/Rank up"
                log.add_report(log_event_dict["level"] % girl.fullname)
                text_changes += stat_increase_dict["level"]
                
                if len(girls) > 1:
                    text_changes += " {size=14}(" + girl.name + "){/size}" # Adds girl name for disambiguation if there are several
                    
            if job_up[girl]:
                ev_type = "Level/Job/Rank up"
                log.add_report(log_event_dict["job_up"] % (girl.fullname, girl.job))
                text_changes += stat_increase_dict["job_up"]
                
                if len(girls) > 1:
                    text_changes += " {size=14}(" + girl.name + "){/size}" # Adds girl name for disambiguation if there are several
        
            if girl.ready_to_rank():
                ev_type = "Level/Job/Rank up"
                log.add_report(log_event_dict["rank"] % girl.fullname)
                text_changes += stat_increase_dict["rank"]
                
                if len(girls) > 1:
                    text_changes += " {size=14}(" + girl.name + "){/size}" # Adds girl name for disambiguation if there are several
        
        text_changes += stat_increase_dict["xp"] % str(round_int(xp_gains[girls[0]]))
        text_changes += stat_increase_dict["jp"] % str(round_int(jp_gains[girls[0]]))
        
        if rep_gains[girls[0]] > 0:
            text_changes += stat_increase_dict["rep"] % str(round_int(rep_gains[girls[0]])) + "\n"
        
        text_changes += get_change_text(stat_gains[girls[0]])
        
        text_changes += tired_changes
        
        text_changes += "\n" + stat_increase_dict["gold+"] % str(round_int(sum(tip_gains.values()))) + tip_special

        
        # Choose perform picture
        
        and_tags = []
        not_tags = ["monster", "beast"] # Monster and beast pictures are not displayed during normal sex
        
        
        if act in all_sex_acts:
            if act != "fetish":
                not_tags.append("machine") # Machine pictures are excluded from normal sex (but not toy)
            if len(customers) <= 1:
                not_tags.append("group") # Group pictures are excluded when there is only one customer
                if len(girls) <= 1:
                    not_tags.append("bisexual") # Bi pictures are excluded when there is only one girl and no group sex
            
            if (girls[0].work_whore or job_filter) and girl.job in all_jobs: # Adds a job tag if the girl is doing work & whore or job_filter is on
                and_tags += perform_job_dict[girls[0].job + "_tags"]
            
            if len(customers) > 1:
                work_pic = girl.get_pic(perform_job_dict["group_tags"], perform_job_dict[act + "_tags"], and_tags = and_tags + [act], not_tags = not_tags, and_priority=False)
            elif len(girls) > 1:
                work_pic = girl.get_pic(perform_job_dict["bisexual_tags"], perform_job_dict[act + "_tags"], and_tags = and_tags + [act], not_tags = not_tags, and_priority=False)
            else:
                work_pic = girls[0].get_pic(perform_job_dict[act + "_tags"], and_tags = and_tags, not_tags = not_tags)
                
            if not work_pic: # Defaults to sex if a picture hasn't been found
                work_pic = girls[0].get_pic("sex")
        
            if not work_pic: # Defaults to naked if a sex picture hasn't been found
                work_pic = girls[0].get_pic("naked")
            
        elif act in all_jobs:
            work_pic = girls[0].get_pic(perform_job_dict[act + "_tags"], perform_job_dict[act + "_tags2"], and_tags = and_tags, not_tags = not_tags, naked_filter=True, soft=True)
                
        if not work_pic:  # Defaults to profile if no other picture has been found
            work_pic = girls[0].get_pic("profile", and_tags = and_tags, not_tags = not_tags, naked_filter=True, soft=True)
            

        # Generate event(s)
        
        events = []
        
        if crazy_ev:
            events.append(crazy_ev)
        
        if rape:
            ev_sound = s_scream_loud
            ev_type = "Health/Security"
        elif rand_item:
            ev_sound = s_spell
        else:
            ev_sound = None
        
        events.append(Event(pic = work_pic, char = girls[0].char, text = text_descript, changes = text_changes, sound = ev_sound, type = ev_type))
            
        # Add special breaking events
            
        if act in all_jobs:
            
            girl = girls[0]
            extra_changes = []
            accepted = False
            
            chance = 10 * girl.get_effect("boost", "customer events")
            
            for cust in customers:
                if cust.get_effect("special", "horny"):
                    chance += 10
            
            if dice(100) <= chance:
                ev_type = "Customer"
                
                if dice(6) >= 4 or girl.naked:
                    
                    if act == "waitress":
                        s_act = "service"
                        s_des = "take care of his cock"
                    elif act == "masseuse":
                        s_act = "sex"
                        s_des = "have sex with him"
                    elif act == "dancer":
                        s_act = "anal"
                        s_des = "let him fuck her ass"
                    elif act == "geisha":
                        s_act = "fetish"
                        s_des = "do kinky stuff with him"
                
                else:
                    s_act = "naked"
                
                
                d = dice(3)
                
                if s_act == "naked":
                    
                    if d == 1: # Obedience
                        text1 = "{size=18}Customers started clamoring for " + girl.name + " to strip naked. Soon, she found herself surrounded by horny customers trying to rip her clothes off."
                        
                        score = girl.get_stat("obedience") - dice(250)
                        
                        if score > 0:
                            text1 += "\n{color=[c_green]}Knowing that customers are always right, she let them take her clothes off one by one until she is completely naked.{/color}"
                            extra_changes.append(("obedience", girl.change_stat("obedience", dice(3))))
                            extra_changes.append(("reputation", girl.change_stat("reputation", 1)))
                            
                            accepted = True
                            
                        elif score > -50:
                            text1 += "\n{color=[c_yellow]}The customers were really insistant, so she agreed to go topless.{/color}\nThe customers would have wanted more, but were happy to fondle her naked breasts while she worked nonetheless."
                            extra_changes.append(("obedience", girl.change_stat("obedience", 1)))
                            
                            girl.raise_preference(s_act)
                            
                        else:
                            text1 += "\n{color=[c_red]}She screamed and pushed the customers away, making a fuss.{/color}\nSeveral customers left, muttering that they had seen churches that were wilder than your brothel."
                            extra_changes.append(("reputation", girl.change_stat("reputation", -1)))
                            extra_changes.append(("brothel reputation", brothel.change_rep(-1)))
                        
                    
                    elif d == 2: # Libido
                        text1 = "{size=18}A horny customer started undressing in the middle of the " + job_room_dict[girl.job] + ". He dared [girl.name] to do the same."
                        
                        score = girl.get_stat("libido") - dice(250)
                        
                        if score > 0:
                            text1 += "\n{color=[c_green]}She was feeling horny and liked the customer, so she agreed.{/color}"
                            extra_changes.append(("libido", girl.change_stat("libido", dice(3))))
                            extra_changes.append(("reputation", girl.change_stat("reputation", 1)))
                            
                            accepted = True
                            
                        elif score > -50:
                            text1 += "\n{color=[c_yellow]}She felt shy and refused, but the customer started grinding against her, lifting her skirt and shirt to give everyone a glimpse at her body.{/color}\nShe felt a little aroused."
                            extra_changes.append(("libido", girl.change_stat("obedience", 1)))
                            
                            girl.raise_preference(s_act)
                            
                        else:
                            text1 += "\n{color=[c_red]}She told the customer to put his clothes on before she called security.{/color}\nThe customer was upset and left."
                            extra_changes.append(("reputation", girl.change_stat("reputation", -1)))
                            extra_changes.append(("brothel reputation", brothel.change_rep(-1)))
                        
                    elif d == 3: # Sensitivity
                        text1 = "{size=18}A drunk customer told [girl.name] he loved her, and that he would be the happiest man in Zan if she would show him her heavenly body."
                    
                        score = girl.get_stat("sensitivity") - dice(250)
                        
                        if score > 0:
                            text1 += "\n{color=[c_green]}All the customers then started begging [girl.name] to do it, so she felt she couldn't refuse.{/color}"
                            extra_changes.append(("sensitivity", girl.change_stat("sensitivity", dice(3))))
                            extra_changes.append(("reputation", girl.change_stat("reputation", 1)))
                            
                            accepted = True
                            
                        elif score > -50:
                            text1 += "\n{color=[c_yellow]}She refused, but the man kept pleading her and was soon joined by other customers.{/color}\nEventually, she agreed to flash her boobs to keep the crowd happy. It turned her on a little."
                            extra_changes.append(("sensitivity", girl.change_stat("sensitivity", 1)))
                            
                            girl.raise_preference(s_act)
                            
                        else:
                            text1 += "\n{color=[c_red]}She snapped and yelled at the customer.{/color}\nHe left unhappy. Other customers overheard and grumbled disapprovingly."
                            extra_changes.append(("reputation", girl.change_stat("reputation", -1)))
                            extra_changes.append(("brothel reputation", brothel.change_rep(-1)))
                    
                    if accepted:
                        pic = girl.get_pic(perform_job_dict[act + "_tags"], "naked", and_tags = "naked", not_tags = ["group", "bisexual", "beast", "monster"])
                    else:
                        pic = work_pic
                        
                    events.append(Event(pic, char = girls[0].char, text = text1, changes = get_change_text(extra_changes), type = ev_type))
                    
                else:
                    
                    if d == 1: # Obedience
                        text1 = "{size=18}A customer ordered " + girl.name + " to give him extra service. He wanted her to " + s_des + "."
                        
                        score = girl.get_stat("obedience") - dice(250)
                        
                        if score > 0:
                            text1 += "\n{color=[c_green]}She obediently accepted the customer's request.{/color}"
                            extra_changes.append(("obedience", girl.change_stat("obedience", dice(3))))
                            extra_changes.append(("reputation", girl.change_stat("reputation", 1)))
                            
                            accepted = True
                            
                        elif score > -50:
                            text1 += "\n{color=[c_yellow]}She politely declines, saying nothing as the customer whips out his cock and starts masturbating while she works.{/color}\nShe is left confused and a little aroused by the whole experience."
                            extra_changes.append(("obedience", girl.change_stat("obedience", 1)))
                            
                            girl.raise_preference(s_act)
                            
                        else:
                            text1 += "\n{color=[c_red]}She told the customer to fuck off.{/color}\nHe left upset, complaining about the bad service at your brothel."
                            extra_changes.append(("reputation", girl.change_stat("reputation", -1)))
                            extra_changes.append(("brothel reputation", brothel.change_rep(-1)))
                        
                    
                    elif d == 2: # Libido
                        text1 = "{size=18}A customer flirted with " + girl.name + " all night. He tried to get her to " + s_des + "."
                        
                        score = girl.get_stat("libido") - dice(250)
                        
                        if score > 0:
                            text1 += "\n{color=[c_green]}She was feeling horny and she liked the customer, so she agreed.{/color}"
                            extra_changes.append(("libido", girl.change_stat("libido", dice(3))))
                            extra_changes.append(("reputation", girl.change_stat("reputation", 1)))
                            
                            accepted = True
                            
                        elif score > -50:
                            text1 += "\n{color=[c_yellow]}She refused, but the customer was very insistent and she felt a little horny.{/color}\nSo she let him fondle her tits and ass a little."
                            extra_changes.append(("libido", girl.change_stat("obedience", 1)))
                            
                            girl.raise_preference(s_act)
                            
                        else:
                            text1 += "\n{color=[c_red]}She got upset and left the room.{/color}\nThe customer was grumpy and disappointed."
                            extra_changes.append(("reputation", girl.change_stat("reputation", -1)))
                            extra_changes.append(("brothel reputation", brothel.change_rep(-1)))
                        
                    elif d == 3: # Sensitivity
                        text1 = "{size=18}A customer told her a very sad and touching story. He asked if she would " + s_des + ", to help him forget his sorrows."
                    
                        score = girl.get_stat("sensitivity") - dice(250)
                        
                        if score > 0:
                            text1 += "\n{color=[c_green]}She was touched by his story, and decided she couldn't refuse him.{/color}"
                            extra_changes.append(("sensitivity", girl.change_stat("sensitivity", dice(3))))
                            extra_changes.append(("reputation", girl.change_stat("reputation", 1)))
                            
                            accepted = True
                            
                        elif score > -50:
                            text1 += "\n{color=[c_yellow]}She gently refused, instead giving the customer a hug.{/color}\nHe was all too eager to take advantage of it and rub himself against her, but she let it slide."
                            extra_changes.append(("sensitivity", girl.change_stat("sensitivity", 1)))
                            
                            girl.raise_preference(s_act)
                            
                        else:
                            text1 += "\n{color=[c_red]}She coldly told the customer off, threatening to call security.{/color}\nHe was upset and left grumbling."
                            extra_changes.append(("reputation", girl.change_stat("reputation", -1)))
                            extra_changes.append(("brothel reputation", brothel.change_rep(-1)))
                    
                    events.append(Event(pic = work_pic, char = girls[0].char, text = text1, changes = get_change_text(extra_changes), type = ev_type))
                    
                    if accepted:
                        events += perform(s_act, [girl], [customers[0]], job_filter=True)
            
        else: # Act weakness discovery (fixations are only discovered by MC interaction for now)
            
            for girl in girls:
                
                if len(customers) > 1:
                    s_act = "group" 
                    plur = "s"
                elif len(girls) > 1:
                    s_act = "bisexual"
                    plur = ""
                else:
                    s_act = act
                    plur = ""
                
                if not girl.personality_unlock[s_act]:
                    
                    ev_type = "Customer"
                    
                    text1 = "{size=18}"
                    
                    pos_reaction, neg_reaction = girl.test_weakness(s_act, unlock=True)
                    
                    if pos_reaction and neg_reaction:
                        text1 += girl.name + " blushes bright red and looks very uncomfortable with " + act_description[s_act] + ". However, her nipples are erect and she becomes noticeably wet. {color=[c_yellow]}It's like she both loves and hates it.{/color}"
                        ev_sound = s_sigh
                    elif pos_reaction:
                        if act == "service":
                            text1 += girl.name + " is flustered by the sight of the customer's dick while servicing him. She starts masturbating as she plays with the customer" + plur + "."
                        elif act == "fetish":
                            text1 += girl.name + "'s pleasure centers are overwhelmed by unknown sensations, and she becomes very wet as the customer toys with her."
                        else:
                            text1 += girl.name + " is very sensitive and she eventully reaches orgasm as she is fucked by the customer" + plur + "."
                        
                        text1 += "\n{color=[c_green]}It seems that she loves " + act_description[s_act] + ".{/color}"
                        ev_sound = s_mmmh
                    elif neg_reaction:
                        text1 += girl.name + " acts very uncomfortable around the customer" + plur + ", something is bothering her. {color=[c_red]}She seems to dislike " + act_description[act] + ".{/color}"
                        ev_sound = s_surprise
                    
                    events.append(Event(pic = work_pic, char = girls[0].char, text = text1, sound = ev_sound, type = ev_type))
                
        
        # Log information for tracking stats
        
        for girl in girls:
            
            log.gold_made += sum(tip_gains.values())
            
            girl.add_log("total_cust", len(customers))
            girl.add_log(act + "_cust", len(customers))
            girl.add_log(act + "_" + result, 1)
            girl.add_log(act + "_score", score)
            girl.add_log(act + "_score_base", 1)
            
            if act in all_sex_acts:
                girl.add_log("whore_cust", len(customers))
                girl.add_log("whore_" + result, 1)
                girl.add_log("whore_score", score)
                girl.add_log("whore_score_base", 1)
            
            girl.add_log("total_xp", xp_gains[girl])
            girl.add_log("total_gold", tip_gains[girl])
            girl.add_log("total_jp", jp_gains[girl])
            girl.add_log("total_rep", rep_gains[girl])
            
            girl.add_log(act + "_xp", xp_gains[girl])
            girl.add_log(act + "_gold", tip_gains[girl])
            girl.add_log(act + "_jp", jp_gains[girl])
            girl.add_log(act + "_rep", rep_gains[girl])
            
            if result in ("very bad", "bad"):
                girl.track_event("bad result", arg=(result, act))
            
            elif result in ("good", "very good", "perfect"):
                girl.track_event("good result", arg=(result, act))
        

        return events

        
    def refresh_quest_girls(girl, quest):
        
        if not quest:
            available_girls = MC.girls
            
        elif quest.type == "quest":

            available_girls = [g for g in MC.girls if quest.test_eligibility(g)[0]]
            if available_girls:
#                renpy.say("", and_text(([g.name for g in available_girls])))
                if girl not in available_girls:
                    girl = available_girls[0]
        else:
            available_girls = MC.girls
            
        return girl, available_girls
                
                
    def update_NPC_items(n):
        
        n.items = []
        n.items.append(get_rand_item("rare"))
        
        return
        
    def weekly_updates():
                
        update_slaves()
        refresh_available_locations()
        update_free_girls()
        cycle_free_girls()
        update_shops()
        update_market()
        update_quests()
        update_NPC_items(NPC_renza)
        update_NPC_items(NPC_captain)
        
        return
    
    def add_event(lbl, chapter=0, date=0, chance = 1.0, type="day", location = None, min_gold = -99999, condition = None, not_condition = None, condition_func = None, call_args=[], once = True, AP_cost = 1, order = 0, weight = 1, room = None):
        
        # Type can be: "city", "day" (plays on main screen), "night" (plays upon ending day), "morning" (plays after night events)
        
        new_event = StoryEvent(label=lbl, chapter=chapter, date=date, chance=chance, type=type, location=location, min_gold=min_gold, condition=condition, not_condition=not_condition, condition_func=condition_func, call_args=call_args, once=once, AP_cost=AP_cost, order=order, weight=weight, room=room)
        
        if type == "city":
            city_events.append(new_event)
        elif type in ("any", "day", "night", "morning"):
            daily_events.append(new_event)
        
    def story_add_event(lbl, type="city", duplicates=True):
        
#        renpy.say("", "Adding event " + lbl)
        if type == "city":
            if duplicates or event_dict[lbl] not in city_events: # Avoids creating duplicate events if duplicates is set to False
                city_events.append(event_dict[lbl])
                
        elif type == "day":
            if duplicates or event_dict[lbl] not in daily_events: # Avoids creating duplicate events if duplicates is set to False
                daily_events.append(event_dict[lbl])
        
        return
        
    def story_remove_event(lbl, type="city"):
        
#            renpy.say("", "Removing event " + lbl)
        
        if type == "city":            
            try:
                city_events.remove(event_dict[lbl])
            except (KeyError, ValueError):
                return False
                
        elif type == "day":
            try:
                daily_events.remove(event_dict[lbl])
            except (KeyError, ValueError):
                return False
            
        return True
        
    def story_set_condition(name, value=True):
        story_flags[name] = value
        return
    
    def get_vp_bounds(girl, girl_list):
        
        if selected_view_mode == "x40" or (selected_view_mode=="Auto" and len(girl_list)>24):
            h = 60
            col = 4
            lines = 10
        elif selected_view_mode == "x24" or (selected_view_mode=="Auto" and len(girl_list)>12):
            h = 80
            col = 3
            lines = 8
        elif selected_view_mode == "x12" or (selected_view_mode=="Auto" and len(girl_list)>4):
            h = 100
            col = 2
            lines = 6
        else:
            h = 125
            col = 1
            lines = 4
        
        if girl in girl_list:
            top_position = girl_list.index(girl)//col * h
            bottom_position = (girl_list.index(girl)//col-(lines-1)) * h
            
            top_bound = top_position - (lines-1) * h
            bottom_bound = bottom_position + (lines-1) * h
            
            return top_bound, bottom_bound
        
        else:
            return 0,0
    
    def focus_vp(girl_list):
        
        # This adjusts the viewport to show the selected girl
        
        if selected_girl in girl_list:
            top_bound, bottom_bound = get_vp_bounds(selected_girl, girl_list)
            
            if vp_adj.value < top_bound:
                vp_adj.change(top_bound)
                
            elif vp_adj.value > bottom_bound:
                vp_adj.change(bottom_bound)

        else:
            vp_adj.change(0)
        
        renpy.restart_interaction()

        return

        
    def select_previous_girl(girl_list, loop=True, pace=1):
        
        global selected_girl
        
        if selected_girl and selected_girl in girl_list:
            previousindex = girl_list.index(selected_girl) - pace
        else:
            previousindex = 0
            
        if previousindex < 0:
            if loop:
                previousindex = len(girl_list) -1
            else:
                previousindex = girl_list.index(selected_girl)
            
        selected_girl = girl_list[previousindex]
        
        focus_vp(girl_list)
        
        return
        
    def get_previous(mylist, current, loop=False, pace=1):
        
        if current in mylist:
            previousindex = mylist.index(current) - pace
        else:
            previousindex = 0
            
        if previousindex < 0:
            if loop:
                previousindex = len(mylist) -1
            else:
                previousindex = mylist.index(current)
            
        return mylist[previousindex]
        
    def get_next(mylist, current, loop=False, pace=1):
        if current in mylist:
            nextindex = mylist.index(current) + pace
        else:
            nextindex = 0
            
        if nextindex > len(mylist) -1:
            if loop:
                nextindex = 0
            else:
                nextindex = len(mylist) -1
        
        return mylist[nextindex]
        
        
    def select_next_girl(girl_list, loop=True, pace=1):
        
        global selected_girl
        
        if selected_girl and selected_girl in girl_list:
            nextindex = girl_list.index(selected_girl) + pace
        else:
            nextindex = 0
            
        if nextindex > len(girl_list) -1:
            if loop:
                nextindex = 0
            else:
                nextindex = girl_list.index(selected_girl)
        
        selected_girl = girl_list[nextindex]
        
#        renpy.notify("Selected girl is " + selected_girl.name)
        
        focus_vp(girl_list)
        
        return
    
    
    def make_tuple(it, obj_type = None): # Wrongly named, this creates a list
        
        if not it:
            return []
        
        if isinstance(it, basestring) or isinstance(it, int) or isinstance(it, float):
            return list([it])
            
        if obj_type:
            if isinstance(it, obj_type):
                return list([it])
        
        return it
            
        
    
    def reverse_if(boost, chg): ## Reverses boost if a stat is decreasing
        
        if chg < 0:
            boost = 1/float(boost)
            
        return boost
            
    def get_change_min_max(val, chg, min, max=999999999999): # Returns change to value after applying min and max
        
#        renpy.say("", "min is " + str(min))
#        renpy.say("", "max is " + str(max))
#        renpy.say("", "chg is " + str(chg))
        
        if min <= val+chg <= max:
            return chg
        
        elif val+chg < min:
            return min - val
        
        elif val+chg > min:
            return max - val
            
        else:
            return 0
    
    
    
    def get_pic_list(thing, tags, and_tags = None, not_tags = None): # For performance reasons, get_pic_list should always receive tuples as arguments
        
        # not_tags will be trimmed if they contradict search_tags. Jury still out on and_tags
        
        if not_tags:
#            not_tags = make_tuple(not_tags)
            for tag in tags:
                if tag in not_tags:
                    not_tags.remove(tag)
#            if and_tags:
#                for tag in and_tags:
#                    if tag in not_tags:
#                        not_tags.remove(tag)
    
        #<Chris12 PackState>
        # Use the new GirlFilesDict
        # Shows unrecognized files based on user settings.
        if isinstance(thing, Girl):
            show_unrecognized = preferences.packstate_unrecognized != "Hide"
            return [pic for pic in GirlFilesDict.get_pics(thing.path) if not pic.is_trash and (not pic.is_unrecognized or show_unrecognized) and pic.has_tags(tags, and_tags, not_tags)]
        #</Chris12 PackState>
        return [pic for pic in thing.pics if pic.has_tags(tags, and_tags, not_tags)]
        
    
    def get_pic(thing, tags, alt_tags1 = None, alt_tags2 = None, alt_tags3 = None, and_tags = None, not_tags = None, strict = False, and_priority=True, attempts=0):
        
        # First looks for a pic with one of 'tags'
        # If stock pictures are deactivated: the search will move to 'alt_tags1' if no pic is found, then 'alt_tags2', then 'alt_tag3'
        # If stock pictures are activated: the search will move to the default pictures
        # The 'and' and 'not_tags' apply to every set of tags.
        # If 'strict' is on, a False value is returned if no picture can be found with the and/not_tags conditions
        # If 'and_priority' is on, the 'and' clause will only be dropped after the search list has been exhausted
        
        piclist = []
        
        tags = make_tuple(tags)
        alt_tags1 = make_tuple(alt_tags1)
        alt_tags2 = make_tuple(alt_tags2)
        alt_tags3 = make_tuple(alt_tags3)
        and_tags = make_tuple(and_tags)
        not_tags = make_tuple(not_tags)
        
        # Tags will be searched in that order
        if persistent.use_stock_pictures["missing"]:
            search_list = [(thing, tags), (game, tags), (thing, alt_tags1), (game, alt_tags1), (thing, alt_tags2),  (game, alt_tags2), (thing, alt_tags3),  (game, alt_tags3)]
        else:
            search_list = [(thing, tags), (thing, alt_tags1), (thing, alt_tags2), (thing, alt_tags3)]
        
#        renpy.say("", "Looking for " + and_text(tags) + " in " + str(thing) + " with " + and_text(and_tags) + " and without " + and_text(not_tags))
#        renpy.say("", str(len(thing.pics)) + " pictures found.")
        
        for target, search_tags in search_list:
            
            attempts += 1
            
            piclist = get_pic_list(target, search_tags, and_tags, not_tags)
            
            # Mix with stock pictures if the number of pictures found is too low and the option has been activated in the H menu
            if persistent.use_stock_pictures["low"] and len(piclist) < stock_picture_threshold and target != game:
                piclist += get_pic_list(game, search_tags, and_tags, not_tags)
            
            if piclist != []:
#                renpy.say("", str(len(piclist)) + " pictures found: " + and_text([p.filename for p in piclist]))
                
                pic = rand_choice(piclist)
                
#                renpy.say("", "Returning: " + pic.filename)

                game.last_pic = {"tags": search_tags, "and_tags": and_tags, "not_tags": not_tags, "attempts": attempts}
                return pic
                
            # If nothing is found, drop the 'and' clauses (and_priority = False). not_tags clause is dropped last.
            
            if not and_priority and not strict:
                
                attempts += 1
                
                piclist = get_pic_list(target, search_tags, not_tags=not_tags)
                
                # Mix with stock pictures if the number of pictures found is too low and the option has been activated in the H menu
                if persistent.use_stock_pictures["low"] and len(piclist) < stock_picture_threshold and target != game:
                    piclist += get_pic_list(game, search_tags, not_tags=not_tags)
                
                if piclist != []:
                    pic = rand_choice(piclist)
                    game.last_pic = {"tags": search_tags, "and_tags": and_tags, "not_tags": not_tags, "attempts": attempts}
                    return pic
                
                attempts += 1
                
                piclist = get_pic_list(target, search_tags)
                
                # Mix with stock pictures if the number of pictures found is too low and the option has been activated in the H menu
                if persistent.use_stock_pictures["low"] and len(piclist) < stock_picture_threshold and target != game:
                    piclist += get_pic_list(game, search_tags)
                
                if piclist != []:
                    pic = rand_choice(piclist)
                    game.last_pic = {"tags": search_tags, "and_tags": and_tags, "not_tags": not_tags, "attempts": attempts}
                    return pic
            
        # If nothing is found, drop the 'and' clauses (and_priority = True). not_tags clause is dropped last.
        
#        renpy.say("", "No matching pictures found.")
        
        if and_priority and not strict:
            
            for target, search_tags in search_list:
                
                attempts += 1
                
                piclist = get_pic_list(target, search_tags, not_tags=not_tags)
                
                # Mix with stock pictures if the number of pictures found is too low and the option has been activated in the H menu
                if persistent.use_stock_pictures["low"] and len(piclist) < stock_picture_threshold and target != game:
                    piclist += get_pic_list(game, search_tags, not_tags=not_tags)
                
                if piclist != []:
                    game.last_pic = {"tags": search_tags, "and_tags": and_tags, "not_tags": not_tags, "attempts": attempts}
                    return rand_choice(piclist)
            
            for target, search_tags in search_list:
                
                attempts += 1
                
                piclist = get_pic_list(target, search_tags)
                
                # Mix with stock pictures if the number of pictures found is too low and the option has been activated in the H menu
                if persistent.use_stock_pictures["low"] and len(piclist) < stock_picture_threshold and target != game:
                    piclist += get_pic_list(game, search_tags)
                
                if piclist != []:
                    game.last_pic = {"tags": search_tags, "and_tags": and_tags, "not_tags": not_tags, "attempts": attempts}
                    return rand_choice(piclist)
        
        game.last_pic = {"tags": search_tags, "and_tags": and_tags, "not_tags": not_tags, "attempts": attempts}
        
        return None
        
        
    def cycle_list(mylist, item, number=1):
        
        if item not in mylist:
            raise AssessmentError, "Item not in list"
            
        idx = (mylist.index(item) + number) % len(mylist)
        
        return mylist[idx]
    
    def move_up_list(mylist, item):
        idx = mylist.index(item)
        if idx > 0:
            mylist.insert(idx-1, mylist.pop(idx))
    
    def move_down_list(mylist, item):
        idx = mylist.index(item)
        if idx < len(mylist):
            mylist.insert(idx+1, mylist.pop(idx))
    
    def can_interact(girl, type = None, slave = True, silent=True): # Antiquated, to be replaced by the GirlInteractionTopic method
    
        if not girl in MC.girls and slave:
            return False
            
        if MC.interactions < 1:
            return False
            
        if type:
            if type == "train" and girl.MC_interact_counters[type] >= 1:
                if not silent:
                    renpy.say("", "You cannot train a girl more than once per day.")
                return False

            elif type in ("present", "money", "offer") and girl.MC_interact_counters[type] >= 1:
                return False
        
            elif type == "offer" and len(MC.girls) >= brothel.bedrooms:
                return False
                
            elif girl.MC_interact_counters[type] >= 3:
                if not silent:
                    renpy.say("", "You cannot do the same things more than 3 times a day with a girl.")
                return False
            
        return True
    
    def get_act_menu(prompt=None, extended=True, girl=None, conditions=True):
        if extended:
            acts = extended_sex_acts
        else:
            acts = all_sex_acts
        
        menu_list = []
        
        if prompt:
            menu_list.append((prompt, None))
        
        for act in acts:
            text1 = act_description["action " + act]
            
            if girl and conditions and training_test_dict[act]: # Tests thresholds for training girls

                condition_met = False
            
                for cond, pref in training_test_dict[act]:
                    if compare_preference(girl, cond, pref):
#                            renpy.say("", "Can display " + act + " because " + cond + " is " + pref + " or more.")
                        condition_met=True
                        break
            else:
                condition_met = True

            if girl:
                if girl.personality_unlock[act]:
                    if act in girl.pos_acts and act in girl.neg_acts:
                        text1 = text1 + " (☯)"
                    elif act in girl.pos_acts:
                        text1 = text1 + " (❤)" 
                    elif act in girl.neg_acts:
                        text1 = text1 + " (⚡)"
                else:
                    text1 = text1 + " (?)"
            
            if condition_met:
                menu_list.append((text1, act))
            
        menu_list.append(("Go back", "back"))
        
        return menu_list
                    
        
    
    def get_fix_menu(act, step = "all", girl = None):
        
        menu_list = []#[(prompt, None),]
        
        fix_list = get_fix_list(act, step)
        
        if girl:
            pos_fix = [f.name for f in girl.pos_fixations]
            neg_fix = [f.name for f in girl.neg_fixations]
        
        for fix in fix_list:
            text1 = fix_description[fix.name + " action"]
            
            if girl:
                if girl.personality_unlock[fix.name]:
                    if fix.name in pos_fix:
                        text1 = text1 + " (❤)"
                    elif fix.name in neg_fix:
                        text1 = text1 + " (⚡)"
                else:
                    text1 = text1 + " (?)"
            
            menu_list.append((text1, fix))
        
        menu_list.append(("Nothing special", "no fix"))
        
        return menu_list
        
    def get_fix_list(act, step = "all"):
        
        if step == "all":
            return [fix for fix in fix_dict.values() if act in fix.acts]
        
        else:
            return [fix for fix in fix_dict.values() if act in fix.acts and step == fix.step]
            
    
    def this_is_a_hentai_game_so_why_are_you_trying_to_act_classy_all_of_a_sudden():
        
        global shake_count
        
        shake_count +=1
        
        if shake_count == 1:
            
            renpy.say(you, "I mean, I could just...", interact=False)
            
        elif shake_count == 2:
            
            renpy.say(you, "You know, just five seconds...", interact=False)
            
        elif shake_count == 3:
        
            renpy.say(you, "It wouldn't hurt anybody...", interact=False)
            
        elif shake_count == 4:
        
            renpy.say(you, "What's... happening to me...", interact=False)
        
        elif shake_count == 5:
        
            renpy.say(you, "I... I can't control myself...", interact=False)
        
            shake_count = 0
            
        shake_mouse()
        
        return
        
    def shake_mouse():
        
        renpy.set_mouse_pos(renpy.get_mouse_pos()[0] + renpy.random.randint(0, 150) - 75, renpy.get_mouse_pos()[1] + (renpy.random.randint(50, 150) * renpy.random.choice((-1, 1))), 0.1)
        
        return
        
    def compare_preference(girl, act, pref, bonus=0): # Returns True if a girl's preference is better or equal to Pref
        
        if preference_modifier[girl.get_preference(act, bonus)] <= preference_modifier[pref]:
            return True
        return False
        
    def get_act_weakness_symbol(girl, act):
               
        if girl.personality_unlock[act]:
            if act in girl.pos_acts and act in girl.neg_acts:
                return " (☯)"
            elif act in girl.pos_acts:
                return " (❤)" 
            elif act in girl.neg_acts:
                return " (⚡)"
            else:
                return ""
        else:
            return " (?)"
        
    def can_use_minion_item():
        
        if MC.get_items(target="minion", name="Healing powder") and farm.get_hurt_minions():
            return True
        if MC.get_items(target="minion", effect_type="gain"):
            for it in MC.get_items(target="minion", effect_type="gain"):
                for eff in it.effects:
                    if eff.target[:-3] in all_minion_types: # This checks if the target effect starts with a minion type, then check if this type of minion exists in the farm (dirty)
                        if farm.get_minions(eff.target[:-3]):
                            return True
        return False
            
    def generate_name(type):
        if type == "stallion":
            return rand_choice(minion_name_dict["consonants"]).capitalize() + rand_choice(minion_name_dict["vowels"]) + rand_choice(minion_name_dict["consonants"])
        elif type == "beast":
#            return rand_choice(minion_name_dict["consonants"]) + rand_choice(minion_name_dict["vowels"]) + rand_choice(minion_name_dict["consonants"]) + rand_choice(minion_name_dict["vowels"])
            cons = rand_choice(minion_name_dict["consonants"])
            return cons.capitalize() + rand_choice(minion_name_dict["vowels"]) + cons + rand_choice(minion_name_dict["vowels"])
        elif type == "monster":
            return rand_choice(minion_name_dict["monster1"]).capitalize() + rand_choice(minion_name_dict["vowels"]) + rand_choice(minion_name_dict["monster2"])
        elif type == "machine":
            return rand_choice(minion_name_dict["consonants"] + minion_name_dict["vowels"]).capitalize() + rand_choice(minion_name_dict["consonants"] + minion_name_dict["vowels"]).capitalize() + "-" + str(99 + dice(900))
        elif type == "girl":
            first_name = ""
            
            syllabs = dice(3)
            
            if syllabs == 1:
                first_name += rand_choice(girl_name_dict["syllabs"]) + rand_choice(girl_name_dict["enders"])
                
            elif syllabs == 2:
                first_name += rand_choice(girl_name_dict["syllabs"]) + rand_choice(girl_name_dict["fillers"]) + rand_choice(girl_name_dict["syllabs"])
                
            elif syllabs == 3:
                first_name += rand_choice(girl_name_dict["syllabs"]) + rand_choice(girl_name_dict["syllabs"]) + rand_choice(girl_name_dict["enders"])
            
            syllabs = dice(4)
            
            last_name = ""
            
            if syllabs == 1:
                last_name = rand_choice(girl_name_dict["last_syllabs"]) + rand_choice(girl_name_dict["enders"])
            else:
                for i in xrange(syllabs):
                    last_name += rand_choice(girl_name_dict["last_syllabs"])
            
            return first_name.capitalize(), last_name.capitalize()
            
            
    def read_init_file(file): ## This compiles a dictionary of values contained in an .ini file. The dictionary acts as a buffer to account for the possibility or user mistakes.
        
        input_dict = defaultdict(list)
        
        ## Read file
        
        parser = ConfigParser.ConfigParser()
        parser.read(config.gamedir + "/" + file)
        
        
        ## list sections and values to search for in the .ini file (update this when the .ini format is updated)
        
        search_for = {
                      "identity" : ["first_name", "last_name", "inverted_name"],
                      "base skills" : gstats_main,
                      "base positive traits" : ["always", "often", "rarely", "never"],
                      "base negative traits" : ["always", "often", "rarely", "never"],
                      "base personality" : ["always", "often", "rarely", "never"],
                      "sexual preferences" : ["favorite_acts", "disliked_acts", "always_fixations", "favorite_fixations", "disliked_fixations", "never_fixations", "sexual_experience", "farm_weakness"],
                      "background story" : ["generate_as", "origin", "origin_description", "init_function", "city_label", "story_label", "night_label", "interact_prompt"],
                      "cloning options" : ["unique", "keep_first_name", "keep_last_name", "keep_inverted", "keep_skills", "keep_traits", "keep_personality", "keep_sex", "keep_generate_as", "keep_init", "keep_background", "keep_interactions"]
                      }
        
        for k, v in search_for.items():
            for thing in v:
                try:
                    input_dict[k + "/" + thing] = ast.literal_eval(parser.get(k, thing.lower()))
                except:
                    if debug_mode:
                        renpy.notify("\nAn error has been found parsing " + k + "/" + thing + " in " + file + ", or it has been intentionally left out.")
                    pass
        
        ## Safety check
                
        for key in ["always", "often", "rarely", "never"]:
            input_dict["base positive traits/" + key] = [t.capitalize() for t in input_dict["base positive traits/" + key]]
            input_dict["base negative traits/" + key] = [t.capitalize() for t in input_dict["base negative traits/" + key]]
            
            for trait in input_dict["base positive traits/" + key] + input_dict["base negative traits/" + key]:
                if trait not in trait_dict.keys():
                    renpy.say("{color=[c_red]}{b}Error parsing " + file + "{/b}{/color}", "{color=[c_red]}" + str(trait) + "{/color} is not a valid trait.\nCheck the correct use of brackets and quotes.")
        
            for pers in input_dict["base personality/" + key]:
                if pers.lower() not in gpersonalities.keys():
                    renpy.say("{color=[c_red]}{b}Error parsing " + file + "{/b}{/color}", "{color=[c_red]}" + str(pers) + "{/color} is not a valid personality.\nCheck the correct use of brackets and quotes.")
                
        for key in ["favorite_acts", "disliked_acts"]:
            input_dict["sexual preferences/" + key] = [p.lower() for p in input_dict["sexual preferences/" + key]]
            
            for act in input_dict["sexual preferences/" + key]:
                if act not in extended_sex_acts:
                    renpy.say("{color=[c_red]}{b}Error parsing " + file + "{/b}{/color}", "{color=[c_red]}" + str(act) + "{/color} is not a valid sex act.\nCheck the correct use of brackets and quotes.")
                
        for key in ["always_fixations", "favorite_fixations", "disliked_fixations", "never_fixations"]:
            input_dict["sexual preferences/" + key] = [p.lower() for p in input_dict["sexual preferences/" + key]]
            
            for fix in input_dict["sexual preferences/" + key]:
                if fix not in fix_dict.keys():
                    renpy.say("{color=[c_red]}{b}Error parsing " + file + "{/b}{/color}", "{color=[c_red]}" + str(fix) + "{/color} is not a valid fixation.\nCheck the correct use of brackets and quotes.")
        
        if input_dict["sexual preferences/sexual_experience"]:
            input_dict["sexual preferences/sexual_experience"] = input_dict["sexual preferences/sexual_experience"].lower()
            
            if input_dict["sexual preferences/sexual_experience"].lower() not in sexual_training_value.keys() + ["random"]:
                renpy.say("{color=[c_red]}{b}Error parsing " + file + "{/b}{/color}", "{color=[c_red]}" + str(input_dict["sexual preferences/sexual_experience"]) + "{/color} is not a valid setting.\nAccepted values are " + '"very experienced", "experienced",  "average", "inexperienced", "very inexperienced", "random".')
        
        if  input_dict["sexual preferences/farm_weakness"]:
            input_dict["sexual preferences/farm_weakness"] = input_dict["sexual preferences/farm_weakness"].lower()
            
            if input_dict["sexual preferences/farm_weakness"] not in all_minion_types + ["random"]:
                renpy.say("{color=[c_red]}{b}Error parsing " + file + "{/b}{/color}", "{color=[c_red]}" + str(input_dict["sexual preferences/farm_weakness"]) + '{/color} is not a valid farm weakness.\nAccepted values are "stallion", "beast", "monster", "machine", "random".')
        
        return input_dict
    
    def clone_init_dict(input_dict):
        
        if not input_dict["cloning options/keep_first_name"]:
            if not persistent.keep_firstname:
                input_dict["identity/first_name"] = None
        if not input_dict["cloning options/keep_last_name"]:
            if not persistent.keep_lastname:
                input_dict["identity/last_name"] = "!rand"
        if not input_dict["cloning options/keep_inverted"]:
            input_dict["identity/inverted_name"] = False
        if not input_dict["cloning options/keep_skills"]:
            for skill in gstats_main:
                input_dict["base skills/" + skill] = 0
        if not input_dict["cloning options/keep_traits"]:
            for key in ["always", "often", "rarely", "never"]:
                input_dict["base positive traits/" + key] = []
                input_dict["base negative traits/" + key] = []
        if not input_dict["cloning options/keep_personality"]:
            for key in ["always", "often", "rarely", "never"]:
                input_dict["base personality/" + key] = []
        if not input_dict["cloning options/keep_sex"]:
            for key in ["favorite_acts", "disliked_acts", "favorite_fixations", "disliked_fixations"]:
                input_dict["sexual preferences/" + key] = []
            input_dict["sexual preferences/sexual_experience"] = "random"
            input_dict["sexual preferences/farm_weakness"] = "random"
        if not input_dict["cloning options/keep_generate_as"]:
            input_dict["background story/generate_as"] = "all"
        if not input_dict["cloning options/keep_init"]:
            input_dict["background story/init_function"] = None
        if not input_dict["cloning options/keep_background"]:
            input_dict["background story/origin"] = "random"
            input_dict["background story/origin_description"] = None
        if not input_dict["cloning options/keep_interactions"]:
            input_dict["background story/city_label"] = None
            input_dict["background story/story_label"] = None
            input_dict["background story/night_label"] = None
            input_dict["background story/interact_prompt"] = None
            
        return input_dict
        
    
    def can_generate(girl, free):
        if girl.count_occurences("all") >= 1 and girl.init_dict["cloning options/unique"]:
            return False        
        elif girl.init_dict["cloning options/keep_generate_as"] and girl.init_dict["background story/generate_as"] == "slave" and free:
            return False
        elif girl.init_dict["cloning options/keep_generate_as"] and girl.init_dict["background story/generate_as"] == "free" and not free:
            return False
        else:
            return True
    
    
    def long_menu(prompt, menu_list, limit=9): # Creates a menu with next/previous commands if menu has many items 
    
        if len(menu_list) <= limit:
            return menu([(prompt, None)] + menu_list)
    
        index = 0
#        part_menu = [(prompt, None)] + menu_list[:limit] + [("{i}Next{/i}", "next")]
            
        while True:
            end = index + limit
            
            if end > len(menu_list):
                end = len(menu_list)
            
            if prompt:
                part_menu = [(prompt, None)] + menu_list[index:end]
            else:
                part_menu = menu_list[index:end]
            
            if index > 0:
                part_menu += [("{i}Previous{/i}", "previous")]
            else:
                part_menu += [("{color=#AAA}{i}Previous{/i}", "previous")]
                
            if end < len(menu_list):
                part_menu += [("{i}Next{/i}", "next")]
            else:
                part_menu += [("{color=#AAA}{i}Next{/i}", "next")]
            
            r = menu(part_menu)
            
            if r == "next":
                if end < len(menu_list):
                    index += limit
            
            elif r == "previous":
                if index > 0:
                    index -= limit
                    
            else:
                return r
    
    def update_mods(): #! Replace messages
        
        global mod_traceback
        
        mod_traceback += "Updating mods... "
        
        # Checks if existing/active mods have been disabled
        
        for name, d in persistent.mods.items():
            if name not in detected_mods.keys():
#                if d["active"]:
#                    renpy.call_screen("OK_screen", title = name + " not found", message = "Active mod: " + name + " couldn't be found, and has been deactivated.\n\n{b}Warning{/b}: In some cases, this might mess with your saved games.")
#                else:
#                    renpy.call_screen("OK_screen", title = name + " not found", message = "Mod: " + name + " couldn't be found, and has been deactivated.")
        
                del persistent.mods[name]
                # reset_updated_games()
                renpy.notify("Mod: " + name + " has been removed.")
                
                mod_traceback += "\n" + "Mod: " + name + " has been removed."
        
        # Checks new mods or new mod versions
        
        for name, mod in detected_mods.items():
            
            # Finding new mod
            
            if name not in persistent.mods.keys():
                register_mod(mod)
                renpy.notify(mod.full_name + " has been added.")
                
                mod_traceback += "\n" + "Mod: " + name + " has been added."
                
            # Finding new version (basic checks: version number and events lenght)
                
            elif mod.check_for_updates():
#                renpy.call_screen("OK_screen", title = mod.name + ": new version found", message = "A different version of this mod: " + mod.name + " has been found ([[mod.version]]). The mod has been reset.")
                register_mod(mod)
                renpy.notify(mod.full_name + " has been updated.")
                mod.active = True
                mod_traceback += "\n" + "Mod: " + name + " has been updated."
                
            # Activating mod if it exists
            
            elif persistent.mods[name]["active"]:
                mod.active = True
#                if debug_mode:
#                    renpy.notify(mod.full_name + " has been activated.")
                mod_traceback += "\n" + "Mod: " + name + " has been activated."
                
        # persistent.mods should now be updated to reflect all currently available mods
    
    def register_mod(mod):
        
        global mod_traceback
        
        persistent.mods[mod.name] = {"version" : mod.version, "check" : mod.get_check(), "active" : mod.active}
                
        mod_traceback += "\n" + "Mod: " + mod.name + " has been registered."
    
#     def reset_mod(mod): #! No longer required
        
#         if renpy.call_screen("yes_no", mod.full_name + " will be reset. Are you sure you want to proceed?\n\n{b}Warning{/b}: The mod will be reset, this might impact your saved games."):
            
#             mod.deactivate()
#             if detected_mods[mod.name]:
#                 # persistent.mods[mod.name] = detected_mods[mod.name]
#                 renpy.notify(mod.full_name + " has been reset.")
#             else:
#                 renpy.call_screen("OK_screen", title="Mod Not Found", message=event_color["bad"] % (mod.full_name + ": This mod couldn't be found among installed mods."))
    
    def reset_updated_games():
        
        global updated_games
        
        updated_games = defaultdict(bool)
        
        
    def get_events(type="any", time=None):
        
        event_list = []
        
        if not time:
            time = calendar.time
            
        for event in daily_events:
            if event.happens(type):
                event_list.append(event)
        
        return event_list
                
        
    def toggle_skip(ev_type):
        if persistent.skipped_events[ev_type]:
            persistent.skipped_events[ev_type] = False
        else:
            persistent.skipped_events[ev_type] = True
            
    
    def get_next_day_report():
        
        msg = "You have " + str(len(MC.girls)) + " girl" + plural(len(MC.girls)) + " in your brothel (max " + str(brothel.bedrooms) + ").\n\n"
        
        working_girls = sum(1 for girl in MC.girls if girl.works_today())
        waitresses = sum(1 for girl in MC.girls if girl.works_today() and girl.job == "waitress")
        dancers = sum(1 for girl in MC.girls if girl.works_today() and girl.job == "dancer")
        masseuses = sum(1 for girl in MC.girls if girl.works_today() and girl.job == "masseuse")
        geishas = sum(1 for girl in MC.girls if girl.works_today() and girl.job == "geisha")
        whores = sum(1 for girl in MC.girls if girl.works_today() and girl.job == "whore")
        away = sum(1 for girl in MC.girls if girl.away)
        resting = sum(1 for girl in MC.girls if not girl.works_today())
        
        msg += str(working_girls) + " girl" + plural(working_girls) + " will be working tonight."
        
        msg += "\n{size=-2}" + "- Waitress: " + event_color["good"] % str(waitresses) + "\n"
        msg += "- Dancer: " + event_color["good"] % str(dancers) + "\n"
        msg += "- Masseuse: " + event_color["good"] % str(masseuses) + "\n"
        msg += "- Geisha: " + event_color["good"] % str(geishas) + "\n"
        msg += "- Whore: " + event_color["good"] % str(whores) + "\n{/size}\n"
        
        if away > 1:
            msg += str(away) + " are away on a quest or class.\n\n"
        elif away > 0:
            msg += str(away) + " is away on a quest or class.\n\n"
        
        msg += str(resting) + " girl" + plural(resting) + " will be resting at the brothel tonight.\n\n"
        
        if farm.active:
            farm_training = sum(1 for girl in farm.girls if farm.programs[girl].target != "no training")
            farm_holding = sum(1 for girl in farm.girls if farm.programs[girl].target == "no training" and farm.programs[girl].holding != "rest")
            farm_resting = sum(1 for girl in farm.girls if farm.programs[girl].target == "no training" and farm.programs[girl].holding == "rest")
            
            msg += str(len(farm.girls)) + " girl" + plural(len(farm.girls)) + " will be at the farm tonight."
            
            msg += "\n{size=-2}" + "- In training: " + event_color["good"] % str(farm_training) + "\n"
            msg += "- In holding: " + event_color["good"] % str(farm_holding) + "\n{/size}\n"
            
            msg += str(farm_resting) + " girl" + plural(farm_resting) + " will be resting at the farm tonight."
        
        return msg
        
        
    def get_warnings():
        
        # Brothel
        
        msg = brothel.get_ASM_report() + "\n\n"
        
        # Escaped girls
        
        for girl in MC.escaped_girls:
            msg += event_color["bad"] % (girl.fullname + " has escaped the brothel and has yet to return.\n")
            
        # Grumbling girls
        
        for girl in MC.girls:
            if girl.run_away_check():
                msg += event_color["a little bad contrast"] % ("Warning! " + girl.fullname + " is grumbling about running away.\n")
        
        # Tired and hurt girls
        
        for girl in MC.girls:
            if girl.tired_check():
                msg += event_color["a little bad contrast"] % (girl.fullname + " is getting tired.\n")
        
            if girl.exhausted:
                msg += event_color["bad"] % (girl.fullname + " is exhausted and cannot work until she is fully rested.\n")
            
            if girl.hurt:
                msg += event_color["bad"] % (girl.fullname + " is hurt and cannot work until she is fully rested.\n")
        
        # News
        
        msg += "\n"
        
        if game.token > 0:
            msg += event_color["special"] % "You are ready to move to a new district.\n\n"
        
        if MC.skill_points > 0:
            msg += event_color["good"] % "You are ready to level up.\n"
        
        ready_to_level = sum(1 for girl in MC.girls if girl.upgrade_points >= 1)
        ready_to_perk = sum(1 for girl in MC.girls if girl.perk_points > 0)
        
        if ready_to_level > 1:
            msg += event_color["good"] % (str(ready_to_level) + " girls have unspent skill points.\n")
        elif ready_to_level > 0:
            msg += event_color["good"] % (str(ready_to_level) + " girl has unspent skill points.\n")
        
        if ready_to_perk > 1:
            msg += event_color["good"] % (str(ready_to_perk) + " girls have unspent perk points.\n")
        elif ready_to_perk > 0:
            msg += event_color["good"] % (str(ready_to_perk) + " girl has unspent perk points.\n")
        
        if shop.updated:
            msg += "The Shop has received new items.\n"
            
        if slavemarket.updated:
            msg += "The Slave Market has received new girls.\n"
            
        if quest_board.updated:
            msg += "There are new Classes and Quests available in town.\n"
        
        return msg
            
        
    def count_customers(rep, girls=[]):

        cust_nb = 0
        total_cust_value = 0

        while total_cust_value < rep: # Each new customer "costs" 1 more point of rep times current rank
            cust_nb += 1
            total_cust_value += cust_nb * district.rank

        extra_cust = sum(g.get_effect("change", "customers", raw=True) for g in girls) + brothel.get_effect("change", "customers")

        return int(cust_nb), int(extra_cust)
        
        
    def change_district(chosen_district):
        
        global brothel
        global district
        global bg_bro
        
        game.blocked_districts.append(district)
        district = chosen_district
        newbrothel = copy.deepcopy(blist[game.chapter])
        
        # Carry name and furniture over to the new brothel
        newbrothel.setup(brothel.name, brothel.furniture, brothel.current_building, brothel.started_building, brothel.master_bedroom.girls, free_room=district.room)
        
        # Switch brothels
        brothel = newbrothel
        
        game.token -= 1
        MC.gold -= blist[game.chapter].cost
        
        # Set BG
        bg_bro = "bg brothel" + str(game.chapter)
        
        # Refresh         
        calendar.updates()
        refresh_available_locations()
        reset_girl_jobs()
        
        # Add story events
        
        if game.chapter == 2:
            story_add_event("c2_intro", type="day")

    
    def get_girlpack_rating(girl):
        
        if rating_dict[girl.path]:
            d = rating_dict[girl.path]
        else:
#            renpy.say("", "Evaluate " + girl.path)
            d = girl.evaluate_girlpack()
            rating_dict[girl.path] = d
        
        score = d["main cover score"] * 5 + d["optional cover score"] * 2
          
        if score >= 6:
            rating = "A"
            col = "special"
        elif score >= 5:
            rating = "B"
            col = "good"
        elif score >= 4:
            rating = "C"
            col = "a little good"
        elif score >= 3:
            rating = "D"
            col = "average"
        elif score >= 2:
            rating = "E"
            col = "a little bad"
        else:
            rating = "F"
            col = "bad"
        
        if d["main diversity average"] > 5:
            rating += "+"
        elif d["main diversity average"] < 3:
            rating += "-"
        
        ttip = "{size=-2}Girlpack rating: " + rating
        #<Chris12 PackState>
        #ttip += "\nPictures: " + str(len(girl.pics))
        ttip += "\nPictures: " + str(len(GirlFilesDict.get_pics(girl.path)))
        #</Chris12 PackState>
        ttip += "\nMain tags score: " + str(round_int(d["main cover score"]*100)) + "% (" + str(round(d["main diversity average"], 1)) + " picture/existing tag)"
        ttip += "\nOptional tags score: " + str(round_int(d["optional cover score"]*100)) + "% (" + str(round(d["optional diversity average"], 1)) + " picture/existing tag)"
                
        return event_color[col] % rating, ttip
            
            
    def is_imgfile(file):
        if file:
            if (file[-4:] in IMGFORMATS or file[-5:] in IMGFORMATS):
                return True
        return False
    
    def list_imgfiles(path, strict=True): # Returns a list of all image files in the given folder (and sub-folders if strict is set to False)
        
        if strict:
            return [f for f in renpy.list_files() if f.startswith(path) and is_imgfile(f) and f.count("/") == path.count("/")]
        
        else:
            return [f for f in renpy.list_files() if f.startswith(path) and is_imgfile(f)]
            
    def get_exchange_rate(source, target): # Where source, target are "gold" or a Resource object
        
        if source == "gold":
            return 1/(resource_gold_value[target.rank] * calendar.get_discount(source, target))
        
        elif target == "gold":
            return resource_gold_value[source.rank]*resource_sell_discount * calendar.get_discount(source, target)
        
        else:
            return resource_base_exchange_rate[source.rank][target.rank]  * calendar.get_discount(source, target)
    
    
    
#### EFFECT MANAGEMENT ####
## Most skills, items, spells, etc. cause effects. Effects are applied to a target: MC, slaves and girls, the brothel...
    
    def get_effect(thing, type, target, custom_scale=("factor", 0), change_cap=False, iterate=False, randomize=True): 
        ## Will return the cumulated value of all applicable effects if test is passed
        # custom_scale is a tuple 'factor name', 'value' which is used for specific perks
        # change_cap=True will only return Effects with the change_cap attribute as True (which means it affects stat min and max)
        
        
        # Choose result type
        
        if type in ("boost"): 
            # result is a % expressed as a float. 1.0 (100%) means no positive or negative effect occur.
            result = 1.0
        else: 
            # result is a number expressed as int or float. 0 means no positive or negative effect occur.
            result = 0
        
        # Checks a dictionary to optimize performance (the dictionary is updated through the update_effects function)
        if iterate:
            effect_list = [eff for eff in thing.effects if type.lower() == eff.type.lower() and target.lower() == eff.target.lower()]
        else:
            effect_list = thing.effect_dict[(type.lower(), target.lower())]
        
        for effect in effect_list:
            
            # Out of scope effects will be ignored to avoid double proc
            
            if (effect.scope == "world" and thing not in (brothel, farm, game)) or (effect.scope == "brothel" and thing != brothel) or (effect.scope == "farm" and thing != farm) or (effect.scope == "city" and thing != game):
                continue
            
            #### APPLIES SCALING EFFECTS ####
            
            if effect.scales_with:
                if effect.source: # This is used for scoped effects to track the original source and scale accordingly
                    factor = get_scale_factor(effect.source, effect.scales_with, custom_scale=custom_scale)
                else:
                    factor = get_scale_factor(thing, effect.scales_with, custom_scale=custom_scale)
            else:
                factor = 1
            
            #### TESTING EFFECT PROC CHANCE ####
            
            chance = effect.chance
            
            if target != "effect chance": # Applies boost to effect chance if there is one
                chance *= (1 + get_effect(thing, "special", "effect chance", iterate=iterate, randomize=randomize)) # Why special and not boost? Description related?

            if chance < 1:
                if renpy.random.random() > chance or not randomize:
                    continue # Jumps to the next effect in the for loop
            
            if change_cap and not effect.change_cap:
                continue # Jumps to the next effect in the for loop

            #### ADDING EFFECT VALUE TO RESULT ####
            else:
                if effect.dice: # Adds the value of a dice with 'effect.value' faces
                    if factor and randomize:
                        result += dice(effect.value * factor) # Warning: Factor affects the number of faces the dice has. It should never be a fraction in that case.
                    else:
                        result += effect.value/2 * factor
                else:
                    result += effect.value * factor

        return result
    
    def add_effects(thing, effects, apply_boost=False, spillover=False, expires = False):
        ## This function adds effects to a target (thing)
        
        effects = make_tuple(effects, obj_type = Effect)
        c = None 
        
        for effect in effects:
            
            # If the effect will affect dress and equipment effects, the equipment is removed BEFORE applying the effect to be equipped back after.
            
            if effect.type == "boost" and effect.target in all_equipement_types:
                it_list = []

                # Removes items first
                for it in thing.equipped:

                    if it.type.name.lower() == effect.target:
                        it_list.append(it)
                        thing.unequip(it)
                
            # Applies effect
#                 effect.value *= modifier
                
                
            #### GAIN AND INSTANTS ####
            ## Gain and Instant effects are applied immediately and not added to active effects. They cannot expire.
            ## Gained value is returned (note: will not work properly if there are more than one effects)
            ## Gain effects affect a character's stats or attributes. Instant effects affect the world or the brothel. They work the same and are mostly hardcoded.
            
            if effect.type in ("gain", "instant"):
                
                if effect.scope == "brothel":
                    for girl in MC.girls:
                        c = effect.gain(girl, apply_boost=apply_boost, spillover=spillover)
                elif effect.scope == "farm":
                    for girl in farm.girls:
                        c = effect.gain(girl, apply_boost=apply_boost, spillover=spillover)
                elif effect.scope == "city":
                    for girl in game.free_girls:
                        c = effect.gain(girl, apply_boost=apply_boost, spillover=spillover)
                elif effect.scope == "world":
                    for girl in MC.girls + farm.girls + game.free_girls:
                        c = effect.gain(girl, apply_boost=apply_boost, spillover=spillover)
                else:
                    c = effect.gain(thing, apply_boost=apply_boost, spillover=spillover)
                
            #### PERSONALITY EFFECTS ####
            ## This forces a personality on a girl (mostly associated with traits). This cannot override the .ini file 'Always' and 'Never' settings.
            ## Personality effects are permanent and are not added to active effects.
            
            elif effect.type == "personality":
                thing.set_personality(effect.target)
                c = effect.target
            
            
            #### OTHER EFFECTS ####
            
            else:
                thing.effects.append(effect)
                thing.effect_dict[(effect.type, effect.target)].append(effect) # Stores active effects in a dictionary for faster access

            
                # Naturist effect
                if effect.type == "special" and effect.target == "naked":
                    if thing not in game.free_girls: # Free girls will not reveal their naturist streak immediately
                        thing.naked = True
            
            # Re-equip items AFTER the boost effect has been applied
            if effect.type == "boost" and effect.target in all_equipement_types:
                for it in it_list:
                    thing.equip(it)
            
        if expires:
            calendar.set_alarm(expires, Event(label = "effect_expired", object = (thing, effects)))

        update_effects()

        return c
        
        
    def remove_effects(thing, effects):
        ## This function removes effects from a target (thing)
        
        effects = make_tuple(effects, obj_type = Effect)
        
        for effect in effects:
            
            #### REMOVE EQUIPMENT BOOST ####
            ## If the effect will affect dress and equipment effects, the equipment is removed BEFORE applying the effect to be equipped back after.
            
            if effect.type == "boost" and effect.target in all_equipement_types:
                it_list = []

                # Removes items first
                for it in thing.equipped:

                    if it.type.name.lower() == effect.target:
                        it_list.append(it)
                        thing.unequip(it)
                
            # Remove effect

            if effect in thing.effects:
                thing.effects.remove(effect)
            if effect in thing.effect_dict[(effect.type, effect.target)]:
                thing.effect_dict[(effect.type, effect.target)].remove(effect)

            
            if effect.type == "boost" and effect.target in all_equipement_types:
                # Re-equip items
                for it in it_list:
                    thing.equip(it)

        update_effects()
        
    
    def get_scale_factor(thing, scales_with, custom_scale=("factor", 0), raw=False):
        
        if scales_with in ("strength", "spirit", "charisma", "speed"):
            factor = MC.get_stat(scales_with, raw=raw)
        elif scales_with == "defense":
            factor = thing.get_defense()
        elif scales_with in ("rep", "reputation"):
            factor = thing.rep
        elif scales_with == "rank":
            factor = thing.rank
        elif scales_with == "equipped": # Counts every piece of equipment
            factor = len(thing.equipped)
        elif scales_with == "district":
            factor = district.rank
        elif scales_with == custom_scale[0]: # Custom scale
            factor = custom_scale[1]
        else:
            factor = 0 # 'scales_with' effects will be ignored if no scale factor is found (avoids unwarranted bonuses)
        
        return factor
    
    def update_effects(): # Updates all world-affecting effects
        
        brothel.effect_dict = defaultdict(list)
        farm.effect_dict = defaultdict(list)
        game.effect_dict = defaultdict(list)
        
        for source in ([g for g in MC.girls if not (g.away or g.hurt or g.exhausted)] + [f for f in brothel.furniture if f.active] + [MC, MC.current_trainer, calendar.moon]):
            if source:
                for effect in source.effects:
                    if effect.scope == "brothel" or effect.scope == "world":
                        brothel.effect_dict[effect.type, effect.target].append(effect)
                        effect.source = source # Tracks source (sometimes useful for applying scaling effects)
                    elif effect.scope == "farm" or effect.scope == "world":
                        farm.effect_dict[effect.type, effect.target].append(effect)
                        effect.source = source # Tracks source (sometimes useful for applying scaling effects)
                    elif effect.scope == "city" or effect.scope == "world":
                        game.effect_dict[effect.type, effect.target].append(effect)
                        effect.source = source # Tracks source (sometimes useful for applying scaling effects)
                        
                        
    def count_lines(s, char_per_line):
        
    # Kills unwanted format characters to avoid artificial character count (rough)
        s = s.replace("{b}", "")
        s = s.replace("{/b}", "")
        s = s.replace("{i}", "")
        s = s.replace("{/i}", "")
        s = s.replace("{color=", "")
        s = s.replace("{/color}=", "")
        
        lines = s.split("\n")
        
        total = len(lines)
        
        for line in lines:
            total += len(line) // char_per_line
            
        if s.endswith("\n"):
            total -= 1
        
        return total
        
    def change_autorest(direction="+"):
        global autorest_limit
        
        if direction == "+" and autorest_limit < 100:
            autorest_limit += 5
        elif direction == "-" and autorest_limit > 0:
            autorest_limit -= 5
        
        
    def get_plus_rating(chg, type="stat"):
        
        if type == "stat":
            if chg > 3:
                r = "+++"
            elif chg > 1:
                r = "++"
            elif chg > 0:
                r = "+"
            elif chg >= -1:
                r = "-"
            elif chg >= -3:
                r = "--"
            else:
                r = "---"

        elif type == "pref":
            if chg > 250:
                r = "+++"
            elif chg > 100:
                r = "++"
            elif chg > 0:
                r = "+"
            elif chg >= -100:
                r = "-"
            elif chg >= -250:
                r = "--"
            else:
                r = "---"

        return "{color=" + color_dict[r] + "}" + r + "{/color}"
        
    def load_girl_status(girls): # Stores statuses in a dictionary that is refreshed every interaction
        s_dict = {}
        
        for girl in girls:
            s_dict[girl] = girl.get_status()
            s_dict[girl, "summary"] = girl.get_status_summary()
            
        return s_dict
            
            